# Dedicated to the public domain under CC0: https://creativecommons.org/publicdomain/zero/1.0/.
# Derived from data published by the Unicode Consortium; see: http://unicode.org/copyright.html.
# Generated by github.com/gwk/legs gen-data.py.
# Source directory: data/09_00.

from typing import Dict, List, Tuple


blocks: Dict[str, Tuple[int, int]] = {
  'Basic_Latin': (0x0000, 0x0080),
  'Latin_1_Supplement': (0x0080, 0x0100),
  'Latin_Extended_A': (0x0100, 0x0180),
  'Latin_Extended_B': (0x0180, 0x0250),
  'IPA_Extensions': (0x0250, 0x02B0),
  'Spacing_Modifier_Letters': (0x02B0, 0x0300),
  'Combining_Diacritical_Marks': (0x0300, 0x0370),
  'Greek_and_Coptic': (0x0370, 0x0400),
  'Cyrillic': (0x0400, 0x0500),
  'Cyrillic_Supplement': (0x0500, 0x0530),
  'Armenian': (0x0530, 0x0590),
  'Hebrew': (0x0590, 0x0600),
  'Arabic': (0x0600, 0x0700),
  'Syriac': (0x0700, 0x0750),
  'Arabic_Supplement': (0x0750, 0x0780),
  'Thaana': (0x0780, 0x07C0),
  'NKo': (0x07C0, 0x0800),
  'Samaritan': (0x0800, 0x0840),
  'Mandaic': (0x0840, 0x0860),
  'Arabic_Extended_A': (0x08A0, 0x0900),
  'Devanagari': (0x0900, 0x0980),
  'Bengali': (0x0980, 0x0A00),
  'Gurmukhi': (0x0A00, 0x0A80),
  'Gujarati': (0x0A80, 0x0B00),
  'Oriya': (0x0B00, 0x0B80),
  'Tamil': (0x0B80, 0x0C00),
  'Telugu': (0x0C00, 0x0C80),
  'Kannada': (0x0C80, 0x0D00),
  'Malayalam': (0x0D00, 0x0D80),
  'Sinhala': (0x0D80, 0x0E00),
  'Thai': (0x0E00, 0x0E80),
  'Lao': (0x0E80, 0x0F00),
  'Tibetan': (0x0F00, 0x1000),
  'Myanmar': (0x1000, 0x10A0),
  'Georgian': (0x10A0, 0x1100),
  'Hangul_Jamo': (0x1100, 0x1200),
  'Ethiopic': (0x1200, 0x1380),
  'Ethiopic_Supplement': (0x1380, 0x13A0),
  'Cherokee': (0x13A0, 0x1400),
  'Unified_Canadian_Aboriginal_Syllabics': (0x1400, 0x1680),
  'Ogham': (0x1680, 0x16A0),
  'Runic': (0x16A0, 0x1700),
  'Tagalog': (0x1700, 0x1720),
  'Hanunoo': (0x1720, 0x1740),
  'Buhid': (0x1740, 0x1760),
  'Tagbanwa': (0x1760, 0x1780),
  'Khmer': (0x1780, 0x1800),
  'Mongolian': (0x1800, 0x18B0),
  'Unified_Canadian_Aboriginal_Syllabics_Extended': (0x18B0, 0x1900),
  'Limbu': (0x1900, 0x1950),
  'Tai_Le': (0x1950, 0x1980),
  'New_Tai_Lue': (0x1980, 0x19E0),
  'Khmer_Symbols': (0x19E0, 0x1A00),
  'Buginese': (0x1A00, 0x1A20),
  'Tai_Tham': (0x1A20, 0x1AB0),
  'Combining_Diacritical_Marks_Extended': (0x1AB0, 0x1B00),
  'Balinese': (0x1B00, 0x1B80),
  'Sundanese': (0x1B80, 0x1BC0),
  'Batak': (0x1BC0, 0x1C00),
  'Lepcha': (0x1C00, 0x1C50),
  'Ol_Chiki': (0x1C50, 0x1C80),
  'Cyrillic_Extended_C': (0x1C80, 0x1C90),
  'Sundanese_Supplement': (0x1CC0, 0x1CD0),
  'Vedic_Extensions': (0x1CD0, 0x1D00),
  'Phonetic_Extensions': (0x1D00, 0x1D80),
  'Phonetic_Extensions_Supplement': (0x1D80, 0x1DC0),
  'Combining_Diacritical_Marks_Supplement': (0x1DC0, 0x1E00),
  'Latin_Extended_Additional': (0x1E00, 0x1F00),
  'Greek_Extended': (0x1F00, 0x2000),
  'General_Punctuation': (0x2000, 0x2070),
  'Superscripts_and_Subscripts': (0x2070, 0x20A0),
  'Currency_Symbols': (0x20A0, 0x20D0),
  'Combining_Diacritical_Marks_for_Symbols': (0x20D0, 0x2100),
  'Letterlike_Symbols': (0x2100, 0x2150),
  'Number_Forms': (0x2150, 0x2190),
  'Arrows': (0x2190, 0x2200),
  'Mathematical_Operators': (0x2200, 0x2300),
  'Miscellaneous_Technical': (0x2300, 0x2400),
  'Control_Pictures': (0x2400, 0x2440),
  'Optical_Character_Recognition': (0x2440, 0x2460),
  'Enclosed_Alphanumerics': (0x2460, 0x2500),
  'Box_Drawing': (0x2500, 0x2580),
  'Block_Elements': (0x2580, 0x25A0),
  'Geometric_Shapes': (0x25A0, 0x2600),
  'Miscellaneous_Symbols': (0x2600, 0x2700),
  'Dingbats': (0x2700, 0x27C0),
  'Miscellaneous_Mathematical_Symbols_A': (0x27C0, 0x27F0),
  'Supplemental_Arrows_A': (0x27F0, 0x2800),
  'Braille_Patterns': (0x2800, 0x2900),
  'Supplemental_Arrows_B': (0x2900, 0x2980),
  'Miscellaneous_Mathematical_Symbols_B': (0x2980, 0x2A00),
  'Supplemental_Mathematical_Operators': (0x2A00, 0x2B00),
  'Miscellaneous_Symbols_and_Arrows': (0x2B00, 0x2C00),
  'Glagolitic': (0x2C00, 0x2C60),
  'Latin_Extended_C': (0x2C60, 0x2C80),
  'Coptic': (0x2C80, 0x2D00),
  'Georgian_Supplement': (0x2D00, 0x2D30),
  'Tifinagh': (0x2D30, 0x2D80),
  'Ethiopic_Extended': (0x2D80, 0x2DE0),
  'Cyrillic_Extended_A': (0x2DE0, 0x2E00),
  'Supplemental_Punctuation': (0x2E00, 0x2E80),
  'CJK_Radicals_Supplement': (0x2E80, 0x2F00),
  'Kangxi_Radicals': (0x2F00, 0x2FE0),
  'Ideographic_Description_Characters': (0x2FF0, 0x3000),
  'CJK_Symbols_and_Punctuation': (0x3000, 0x3040),
  'Hiragana': (0x3040, 0x30A0),
  'Katakana': (0x30A0, 0x3100),
  'Bopomofo': (0x3100, 0x3130),
  'Hangul_Compatibility_Jamo': (0x3130, 0x3190),
  'Kanbun': (0x3190, 0x31A0),
  'Bopomofo_Extended': (0x31A0, 0x31C0),
  'CJK_Strokes': (0x31C0, 0x31F0),
  'Katakana_Phonetic_Extensions': (0x31F0, 0x3200),
  'Enclosed_CJK_Letters_and_Months': (0x3200, 0x3300),
  'CJK_Compatibility': (0x3300, 0x3400),
  'CJK_Unified_Ideographs_Extension_A': (0x3400, 0x4DC0),
  'Yijing_Hexagram_Symbols': (0x4DC0, 0x4E00),
  'CJK_Unified_Ideographs': (0x4E00, 0xA000),
  'Yi_Syllables': (0xA000, 0xA490),
  'Yi_Radicals': (0xA490, 0xA4D0),
  'Lisu': (0xA4D0, 0xA500),
  'Vai': (0xA500, 0xA640),
  'Cyrillic_Extended_B': (0xA640, 0xA6A0),
  'Bamum': (0xA6A0, 0xA700),
  'Modifier_Tone_Letters': (0xA700, 0xA720),
  'Latin_Extended_D': (0xA720, 0xA800),
  'Syloti_Nagri': (0xA800, 0xA830),
  'Common_Indic_Number_Forms': (0xA830, 0xA840),
  'Phags_pa': (0xA840, 0xA880),
  'Saurashtra': (0xA880, 0xA8E0),
  'Devanagari_Extended': (0xA8E0, 0xA900),
  'Kayah_Li': (0xA900, 0xA930),
  'Rejang': (0xA930, 0xA960),
  'Hangul_Jamo_Extended_A': (0xA960, 0xA980),
  'Javanese': (0xA980, 0xA9E0),
  'Myanmar_Extended_B': (0xA9E0, 0xAA00),
  'Cham': (0xAA00, 0xAA60),
  'Myanmar_Extended_A': (0xAA60, 0xAA80),
  'Tai_Viet': (0xAA80, 0xAAE0),
  'Meetei_Mayek_Extensions': (0xAAE0, 0xAB00),
  'Ethiopic_Extended_A': (0xAB00, 0xAB30),
  'Latin_Extended_E': (0xAB30, 0xAB70),
  'Cherokee_Supplement': (0xAB70, 0xABC0),
  'Meetei_Mayek': (0xABC0, 0xAC00),
  'Hangul_Syllables': (0xAC00, 0xD7B0),
  'Hangul_Jamo_Extended_B': (0xD7B0, 0xD800),
  'High_Surrogates': (0xD800, 0xDB80),
  'High_Private_Use_Surrogates': (0xDB80, 0xDC00),
  'Low_Surrogates': (0xDC00, 0xE000),
  'Private_Use_Area': (0xE000, 0xF900),
  'CJK_Compatibility_Ideographs': (0xF900, 0xFB00),
  'Alphabetic_Presentation_Forms': (0xFB00, 0xFB50),
  'Arabic_Presentation_Forms_A': (0xFB50, 0xFE00),
  'Variation_Selectors': (0xFE00, 0xFE10),
  'Vertical_Forms': (0xFE10, 0xFE20),
  'Combining_Half_Marks': (0xFE20, 0xFE30),
  'CJK_Compatibility_Forms': (0xFE30, 0xFE50),
  'Small_Form_Variants': (0xFE50, 0xFE70),
  'Arabic_Presentation_Forms_B': (0xFE70, 0xFF00),
  'Halfwidth_and_Fullwidth_Forms': (0xFF00, 0xFFF0),
  'Specials': (0xFFF0, 0x10000),
  'Linear_B_Syllabary': (0x10000, 0x10080),
  'Linear_B_Ideograms': (0x10080, 0x10100),
  'Aegean_Numbers': (0x10100, 0x10140),
  'Ancient_Greek_Numbers': (0x10140, 0x10190),
  'Ancient_Symbols': (0x10190, 0x101D0),
  'Phaistos_Disc': (0x101D0, 0x10200),
  'Lycian': (0x10280, 0x102A0),
  'Carian': (0x102A0, 0x102E0),
  'Coptic_Epact_Numbers': (0x102E0, 0x10300),
  'Old_Italic': (0x10300, 0x10330),
  'Gothic': (0x10330, 0x10350),
  'Old_Permic': (0x10350, 0x10380),
  'Ugaritic': (0x10380, 0x103A0),
  'Old_Persian': (0x103A0, 0x103E0),
  'Deseret': (0x10400, 0x10450),
  'Shavian': (0x10450, 0x10480),
  'Osmanya': (0x10480, 0x104B0),
  'Osage': (0x104B0, 0x10500),
  'Elbasan': (0x10500, 0x10530),
  'Caucasian_Albanian': (0x10530, 0x10570),
  'Linear_A': (0x10600, 0x10780),
  'Cypriot_Syllabary': (0x10800, 0x10840),
  'Imperial_Aramaic': (0x10840, 0x10860),
  'Palmyrene': (0x10860, 0x10880),
  'Nabataean': (0x10880, 0x108B0),
  'Hatran': (0x108E0, 0x10900),
  'Phoenician': (0x10900, 0x10920),
  'Lydian': (0x10920, 0x10940),
  'Meroitic_Hieroglyphs': (0x10980, 0x109A0),
  'Meroitic_Cursive': (0x109A0, 0x10A00),
  'Kharoshthi': (0x10A00, 0x10A60),
  'Old_South_Arabian': (0x10A60, 0x10A80),
  'Old_North_Arabian': (0x10A80, 0x10AA0),
  'Manichaean': (0x10AC0, 0x10B00),
  'Avestan': (0x10B00, 0x10B40),
  'Inscriptional_Parthian': (0x10B40, 0x10B60),
  'Inscriptional_Pahlavi': (0x10B60, 0x10B80),
  'Psalter_Pahlavi': (0x10B80, 0x10BB0),
  'Old_Turkic': (0x10C00, 0x10C50),
  'Old_Hungarian': (0x10C80, 0x10D00),
  'Rumi_Numeral_Symbols': (0x10E60, 0x10E80),
  'Brahmi': (0x11000, 0x11080),
  'Kaithi': (0x11080, 0x110D0),
  'Sora_Sompeng': (0x110D0, 0x11100),
  'Chakma': (0x11100, 0x11150),
  'Mahajani': (0x11150, 0x11180),
  'Sharada': (0x11180, 0x111E0),
  'Sinhala_Archaic_Numbers': (0x111E0, 0x11200),
  'Khojki': (0x11200, 0x11250),
  'Multani': (0x11280, 0x112B0),
  'Khudawadi': (0x112B0, 0x11300),
  'Grantha': (0x11300, 0x11380),
  'Newa': (0x11400, 0x11480),
  'Tirhuta': (0x11480, 0x114E0),
  'Siddham': (0x11580, 0x11600),
  'Modi': (0x11600, 0x11660),
  'Mongolian_Supplement': (0x11660, 0x11680),
  'Takri': (0x11680, 0x116D0),
  'Ahom': (0x11700, 0x11740),
  'Warang_Citi': (0x118A0, 0x11900),
  'Pau_Cin_Hau': (0x11AC0, 0x11B00),
  'Bhaiksuki': (0x11C00, 0x11C70),
  'Marchen': (0x11C70, 0x11CC0),
  'Cuneiform': (0x12000, 0x12400),
  'Cuneiform_Numbers_and_Punctuation': (0x12400, 0x12480),
  'Early_Dynastic_Cuneiform': (0x12480, 0x12550),
  'Egyptian_Hieroglyphs': (0x13000, 0x13430),
  'Anatolian_Hieroglyphs': (0x14400, 0x14680),
  'Bamum_Supplement': (0x16800, 0x16A40),
  'Mro': (0x16A40, 0x16A70),
  'Bassa_Vah': (0x16AD0, 0x16B00),
  'Pahawh_Hmong': (0x16B00, 0x16B90),
  'Miao': (0x16F00, 0x16FA0),
  'Ideographic_Symbols_and_Punctuation': (0x16FE0, 0x17000),
  'Tangut': (0x17000, 0x18800),
  'Tangut_Components': (0x18800, 0x18B00),
  'Kana_Supplement': (0x1B000, 0x1B100),
  'Duployan': (0x1BC00, 0x1BCA0),
  'Shorthand_Format_Controls': (0x1BCA0, 0x1BCB0),
  'Byzantine_Musical_Symbols': (0x1D000, 0x1D100),
  'Musical_Symbols': (0x1D100, 0x1D200),
  'Ancient_Greek_Musical_Notation': (0x1D200, 0x1D250),
  'Tai_Xuan_Jing_Symbols': (0x1D300, 0x1D360),
  'Counting_Rod_Numerals': (0x1D360, 0x1D380),
  'Mathematical_Alphanumeric_Symbols': (0x1D400, 0x1D800),
  'Sutton_SignWriting': (0x1D800, 0x1DAB0),
  'Glagolitic_Supplement': (0x1E000, 0x1E030),
  'Mende_Kikakui': (0x1E800, 0x1E8E0),
  'Adlam': (0x1E900, 0x1E960),
  'Arabic_Mathematical_Alphabetic_Symbols': (0x1EE00, 0x1EF00),
  'Mahjong_Tiles': (0x1F000, 0x1F030),
  'Domino_Tiles': (0x1F030, 0x1F0A0),
  'Playing_Cards': (0x1F0A0, 0x1F100),
  'Enclosed_Alphanumeric_Supplement': (0x1F100, 0x1F200),
  'Enclosed_Ideographic_Supplement': (0x1F200, 0x1F300),
  'Miscellaneous_Symbols_and_Pictographs': (0x1F300, 0x1F600),
  'Emoticons': (0x1F600, 0x1F650),
  'Ornamental_Dingbats': (0x1F650, 0x1F680),
  'Transport_and_Map_Symbols': (0x1F680, 0x1F700),
  'Alchemical_Symbols': (0x1F700, 0x1F780),
  'Geometric_Shapes_Extended': (0x1F780, 0x1F800),
  'Supplemental_Arrows_C': (0x1F800, 0x1F900),
  'Supplemental_Symbols_and_Pictographs': (0x1F900, 0x1FA00),
  'CJK_Unified_Ideographs_Extension_B': (0x20000, 0x2A6E0),
  'CJK_Unified_Ideographs_Extension_C': (0x2A700, 0x2B740),
  'CJK_Unified_Ideographs_Extension_D': (0x2B740, 0x2B820),
  'CJK_Unified_Ideographs_Extension_E': (0x2B820, 0x2CEB0),
  'CJK_Compatibility_Ideographs_Supplement': (0x2F800, 0x2FA20),
  'Tags': (0xE0000, 0xE0080),
  'Variation_Selectors_Supplement': (0xE0100, 0xE01F0),
  'Supplementary_Private_Use_Area_A': (0xF0000, 0x100000),
  'Supplementary_Private_Use_Area_B': (0x100000, 0x110000),
}


category_ranges: Dict[str, Tuple[Tuple[int, int], ...]] = {
  'Cc': (
    (0x0000, 0x0020), (0x007F, 0x00A0),
  ),

  'Cf': (
    (0x00AD, 0x00AE), (0x0600, 0x0606), (0x061C, 0x061D), (0x06DD, 0x06DE),
    (0x070F, 0x0710), (0x08E2, 0x08E3), (0x180E, 0x180F), (0x200B, 0x2010),
    (0x202A, 0x202F), (0x2060, 0x2065), (0x2066, 0x2070), (0xFEFF, 0xFF00),
    (0xFFF9, 0xFFFC), (0x110BD, 0x110BE), (0x1BCA0, 0x1BCA4), (0x1D173, 0x1D17B),
    (0xE0001, 0xE0002), (0xE0020, 0xE0080),
  ),

  'Cn': (
    (0x0378, 0x037A), (0x0380, 0x0384), (0x038B, 0x038C), (0x038D, 0x038E),
    (0x03A2, 0x03A3), (0x0530, 0x0531), (0x0557, 0x0559), (0x0560, 0x0561),
    (0x0588, 0x0589), (0x058B, 0x058D), (0x0590, 0x0591), (0x05C8, 0x05D0),
    (0x05EB, 0x05F0), (0x05F5, 0x0600), (0x061D, 0x061E), (0x070E, 0x070F),
    (0x074B, 0x074D), (0x07B2, 0x07C0), (0x07FB, 0x0800), (0x082E, 0x0830),
    (0x083F, 0x0840), (0x085C, 0x085E), (0x085F, 0x08A0), (0x08B5, 0x08B6),
    (0x08BE, 0x08D4), (0x0984, 0x0985), (0x098D, 0x098F), (0x0991, 0x0993),
    (0x09A9, 0x09AA), (0x09B1, 0x09B2), (0x09B3, 0x09B6), (0x09BA, 0x09BC),
    (0x09C5, 0x09C7), (0x09C9, 0x09CB), (0x09CF, 0x09D7), (0x09D8, 0x09DC),
    (0x09DE, 0x09DF), (0x09E4, 0x09E6), (0x09FC, 0x0A01), (0x0A04, 0x0A05),
    (0x0A0B, 0x0A0F), (0x0A11, 0x0A13), (0x0A29, 0x0A2A), (0x0A31, 0x0A32),
    (0x0A34, 0x0A35), (0x0A37, 0x0A38), (0x0A3A, 0x0A3C), (0x0A3D, 0x0A3E),
    (0x0A43, 0x0A47), (0x0A49, 0x0A4B), (0x0A4E, 0x0A51), (0x0A52, 0x0A59),
    (0x0A5D, 0x0A5E), (0x0A5F, 0x0A66), (0x0A76, 0x0A81), (0x0A84, 0x0A85),
    (0x0A8E, 0x0A8F), (0x0A92, 0x0A93), (0x0AA9, 0x0AAA), (0x0AB1, 0x0AB2),
    (0x0AB4, 0x0AB5), (0x0ABA, 0x0ABC), (0x0AC6, 0x0AC7), (0x0ACA, 0x0ACB),
    (0x0ACE, 0x0AD0), (0x0AD1, 0x0AE0), (0x0AE4, 0x0AE6), (0x0AF2, 0x0AF9),
    (0x0AFA, 0x0B01), (0x0B04, 0x0B05), (0x0B0D, 0x0B0F), (0x0B11, 0x0B13),
    (0x0B29, 0x0B2A), (0x0B31, 0x0B32), (0x0B34, 0x0B35), (0x0B3A, 0x0B3C),
    (0x0B45, 0x0B47), (0x0B49, 0x0B4B), (0x0B4E, 0x0B56), (0x0B58, 0x0B5C),
    (0x0B5E, 0x0B5F), (0x0B64, 0x0B66), (0x0B78, 0x0B82), (0x0B84, 0x0B85),
    (0x0B8B, 0x0B8E), (0x0B91, 0x0B92), (0x0B96, 0x0B99), (0x0B9B, 0x0B9C),
    (0x0B9D, 0x0B9E), (0x0BA0, 0x0BA3), (0x0BA5, 0x0BA8), (0x0BAB, 0x0BAE),
    (0x0BBA, 0x0BBE), (0x0BC3, 0x0BC6), (0x0BC9, 0x0BCA), (0x0BCE, 0x0BD0),
    (0x0BD1, 0x0BD7), (0x0BD8, 0x0BE6), (0x0BFB, 0x0C00), (0x0C04, 0x0C05),
    (0x0C0D, 0x0C0E), (0x0C11, 0x0C12), (0x0C29, 0x0C2A), (0x0C3A, 0x0C3D),
    (0x0C45, 0x0C46), (0x0C49, 0x0C4A), (0x0C4E, 0x0C55), (0x0C57, 0x0C58),
    (0x0C5B, 0x0C60), (0x0C64, 0x0C66), (0x0C70, 0x0C78), (0x0C84, 0x0C85),
    (0x0C8D, 0x0C8E), (0x0C91, 0x0C92), (0x0CA9, 0x0CAA), (0x0CB4, 0x0CB5),
    (0x0CBA, 0x0CBC), (0x0CC5, 0x0CC6), (0x0CC9, 0x0CCA), (0x0CCE, 0x0CD5),
    (0x0CD7, 0x0CDE), (0x0CDF, 0x0CE0), (0x0CE4, 0x0CE6), (0x0CF0, 0x0CF1),
    (0x0CF3, 0x0D01), (0x0D04, 0x0D05), (0x0D0D, 0x0D0E), (0x0D11, 0x0D12),
    (0x0D3B, 0x0D3D), (0x0D45, 0x0D46), (0x0D49, 0x0D4A), (0x0D50, 0x0D54),
    (0x0D64, 0x0D66), (0x0D80, 0x0D82), (0x0D84, 0x0D85), (0x0D97, 0x0D9A),
    (0x0DB2, 0x0DB3), (0x0DBC, 0x0DBD), (0x0DBE, 0x0DC0), (0x0DC7, 0x0DCA),
    (0x0DCB, 0x0DCF), (0x0DD5, 0x0DD6), (0x0DD7, 0x0DD8), (0x0DE0, 0x0DE6),
    (0x0DF0, 0x0DF2), (0x0DF5, 0x0E01), (0x0E3B, 0x0E3F), (0x0E5C, 0x0E81),
    (0x0E83, 0x0E84), (0x0E85, 0x0E87), (0x0E89, 0x0E8A), (0x0E8B, 0x0E8D),
    (0x0E8E, 0x0E94), (0x0E98, 0x0E99), (0x0EA0, 0x0EA1), (0x0EA4, 0x0EA5),
    (0x0EA6, 0x0EA7), (0x0EA8, 0x0EAA), (0x0EAC, 0x0EAD), (0x0EBA, 0x0EBB),
    (0x0EBE, 0x0EC0), (0x0EC5, 0x0EC6), (0x0EC7, 0x0EC8), (0x0ECE, 0x0ED0),
    (0x0EDA, 0x0EDC), (0x0EE0, 0x0F00), (0x0F48, 0x0F49), (0x0F6D, 0x0F71),
    (0x0F98, 0x0F99), (0x0FBD, 0x0FBE), (0x0FCD, 0x0FCE), (0x0FDB, 0x1000),
    (0x10C6, 0x10C7), (0x10C8, 0x10CD), (0x10CE, 0x10D0), (0x1249, 0x124A),
    (0x124E, 0x1250), (0x1257, 0x1258), (0x1259, 0x125A), (0x125E, 0x1260),
    (0x1289, 0x128A), (0x128E, 0x1290), (0x12B1, 0x12B2), (0x12B6, 0x12B8),
    (0x12BF, 0x12C0), (0x12C1, 0x12C2), (0x12C6, 0x12C8), (0x12D7, 0x12D8),
    (0x1311, 0x1312), (0x1316, 0x1318), (0x135B, 0x135D), (0x137D, 0x1380),
    (0x139A, 0x13A0), (0x13F6, 0x13F8), (0x13FE, 0x1400), (0x169D, 0x16A0),
    (0x16F9, 0x1700), (0x170D, 0x170E), (0x1715, 0x1720), (0x1737, 0x1740),
    (0x1754, 0x1760), (0x176D, 0x176E), (0x1771, 0x1772), (0x1774, 0x1780),
    (0x17DE, 0x17E0), (0x17EA, 0x17F0), (0x17FA, 0x1800), (0x180F, 0x1810),
    (0x181A, 0x1820), (0x1878, 0x1880), (0x18AB, 0x18B0), (0x18F6, 0x1900),
    (0x191F, 0x1920), (0x192C, 0x1930), (0x193C, 0x1940), (0x1941, 0x1944),
    (0x196E, 0x1970), (0x1975, 0x1980), (0x19AC, 0x19B0), (0x19CA, 0x19D0),
    (0x19DB, 0x19DE), (0x1A1C, 0x1A1E), (0x1A5F, 0x1A60), (0x1A7D, 0x1A7F),
    (0x1A8A, 0x1A90), (0x1A9A, 0x1AA0), (0x1AAE, 0x1AB0), (0x1ABF, 0x1B00),
    (0x1B4C, 0x1B50), (0x1B7D, 0x1B80), (0x1BF4, 0x1BFC), (0x1C38, 0x1C3B),
    (0x1C4A, 0x1C4D), (0x1C89, 0x1CC0), (0x1CC8, 0x1CD0), (0x1CF7, 0x1CF8),
    (0x1CFA, 0x1D00), (0x1DF6, 0x1DFB), (0x1F16, 0x1F18), (0x1F1E, 0x1F20),
    (0x1F46, 0x1F48), (0x1F4E, 0x1F50), (0x1F58, 0x1F59), (0x1F5A, 0x1F5B),
    (0x1F5C, 0x1F5D), (0x1F5E, 0x1F5F), (0x1F7E, 0x1F80), (0x1FB5, 0x1FB6),
    (0x1FC5, 0x1FC6), (0x1FD4, 0x1FD6), (0x1FDC, 0x1FDD), (0x1FF0, 0x1FF2),
    (0x1FF5, 0x1FF6), (0x1FFF, 0x2000), (0x2065, 0x2066), (0x2072, 0x2074),
    (0x208F, 0x2090), (0x209D, 0x20A0), (0x20BF, 0x20D0), (0x20F1, 0x2100),
    (0x218C, 0x2190), (0x23FF, 0x2400), (0x2427, 0x2440), (0x244B, 0x2460),
    (0x2B74, 0x2B76), (0x2B96, 0x2B98), (0x2BBA, 0x2BBD), (0x2BC9, 0x2BCA),
    (0x2BD2, 0x2BEC), (0x2BF0, 0x2C00), (0x2C2F, 0x2C30), (0x2C5F, 0x2C60),
    (0x2CF4, 0x2CF9), (0x2D26, 0x2D27), (0x2D28, 0x2D2D), (0x2D2E, 0x2D30),
    (0x2D68, 0x2D6F), (0x2D71, 0x2D7F), (0x2D97, 0x2DA0), (0x2DA7, 0x2DA8),
    (0x2DAF, 0x2DB0), (0x2DB7, 0x2DB8), (0x2DBF, 0x2DC0), (0x2DC7, 0x2DC8),
    (0x2DCF, 0x2DD0), (0x2DD7, 0x2DD8), (0x2DDF, 0x2DE0), (0x2E45, 0x2E80),
    (0x2E9A, 0x2E9B), (0x2EF4, 0x2F00), (0x2FD6, 0x2FF0), (0x2FFC, 0x3000),
    (0x3040, 0x3041), (0x3097, 0x3099), (0x3100, 0x3105), (0x312E, 0x3131),
    (0x318F, 0x3190), (0x31BB, 0x31C0), (0x31E4, 0x31F0), (0x321F, 0x3220),
    (0x32FF, 0x3300), (0x4DB6, 0x4DC0), (0x9FD6, 0xA000), (0xA48D, 0xA490),
    (0xA4C7, 0xA4D0), (0xA62C, 0xA640), (0xA6F8, 0xA700), (0xA7AF, 0xA7B0),
    (0xA7B8, 0xA7F7), (0xA82C, 0xA830), (0xA83A, 0xA840), (0xA878, 0xA880),
    (0xA8C6, 0xA8CE), (0xA8DA, 0xA8E0), (0xA8FE, 0xA900), (0xA954, 0xA95F),
    (0xA97D, 0xA980), (0xA9CE, 0xA9CF), (0xA9DA, 0xA9DE), (0xA9FF, 0xAA00),
    (0xAA37, 0xAA40), (0xAA4E, 0xAA50), (0xAA5A, 0xAA5C), (0xAAC3, 0xAADB),
    (0xAAF7, 0xAB01), (0xAB07, 0xAB09), (0xAB0F, 0xAB11), (0xAB17, 0xAB20),
    (0xAB27, 0xAB28), (0xAB2F, 0xAB30), (0xAB66, 0xAB70), (0xABEE, 0xABF0),
    (0xABFA, 0xAC00), (0xD7A4, 0xD7B0), (0xD7C7, 0xD7CB), (0xD7FC, 0xD800),
    (0xFA6E, 0xFA70), (0xFADA, 0xFB00), (0xFB07, 0xFB13), (0xFB18, 0xFB1D),
    (0xFB37, 0xFB38), (0xFB3D, 0xFB3E), (0xFB3F, 0xFB40), (0xFB42, 0xFB43),
    (0xFB45, 0xFB46), (0xFBC2, 0xFBD3), (0xFD40, 0xFD50), (0xFD90, 0xFD92),
    (0xFDC8, 0xFDF0), (0xFDFE, 0xFE00), (0xFE1A, 0xFE20), (0xFE53, 0xFE54),
    (0xFE67, 0xFE68), (0xFE6C, 0xFE70), (0xFE75, 0xFE76), (0xFEFD, 0xFEFF),
    (0xFF00, 0xFF01), (0xFFBF, 0xFFC2), (0xFFC8, 0xFFCA), (0xFFD0, 0xFFD2),
    (0xFFD8, 0xFFDA), (0xFFDD, 0xFFE0), (0xFFE7, 0xFFE8), (0xFFEF, 0xFFF9),
    (0xFFFE, 0x10000), (0x1000C, 0x1000D), (0x10027, 0x10028), (0x1003B, 0x1003C),
    (0x1003E, 0x1003F), (0x1004E, 0x10050), (0x1005E, 0x10080), (0x100FB, 0x10100),
    (0x10103, 0x10107), (0x10134, 0x10137), (0x1018F, 0x10190), (0x1019C, 0x101A0),
    (0x101A1, 0x101D0), (0x101FE, 0x10280), (0x1029D, 0x102A0), (0x102D1, 0x102E0),
    (0x102FC, 0x10300), (0x10324, 0x10330), (0x1034B, 0x10350), (0x1037B, 0x10380),
    (0x1039E, 0x1039F), (0x103C4, 0x103C8), (0x103D6, 0x10400), (0x1049E, 0x104A0),
    (0x104AA, 0x104B0), (0x104D4, 0x104D8), (0x104FC, 0x10500), (0x10528, 0x10530),
    (0x10564, 0x1056F), (0x10570, 0x10600), (0x10737, 0x10740), (0x10756, 0x10760),
    (0x10768, 0x10800), (0x10806, 0x10808), (0x10809, 0x1080A), (0x10836, 0x10837),
    (0x10839, 0x1083C), (0x1083D, 0x1083F), (0x10856, 0x10857), (0x1089F, 0x108A7),
    (0x108B0, 0x108E0), (0x108F3, 0x108F4), (0x108F6, 0x108FB), (0x1091C, 0x1091F),
    (0x1093A, 0x1093F), (0x10940, 0x10980), (0x109B8, 0x109BC), (0x109D0, 0x109D2),
    (0x10A04, 0x10A05), (0x10A07, 0x10A0C), (0x10A14, 0x10A15), (0x10A18, 0x10A19),
    (0x10A34, 0x10A38), (0x10A3B, 0x10A3F), (0x10A48, 0x10A50), (0x10A59, 0x10A60),
    (0x10AA0, 0x10AC0), (0x10AE7, 0x10AEB), (0x10AF7, 0x10B00), (0x10B36, 0x10B39),
    (0x10B56, 0x10B58), (0x10B73, 0x10B78), (0x10B92, 0x10B99), (0x10B9D, 0x10BA9),
    (0x10BB0, 0x10C00), (0x10C49, 0x10C80), (0x10CB3, 0x10CC0), (0x10CF3, 0x10CFA),
    (0x10D00, 0x10E60), (0x10E7F, 0x11000), (0x1104E, 0x11052), (0x11070, 0x1107F),
    (0x110C2, 0x110D0), (0x110E9, 0x110F0), (0x110FA, 0x11100), (0x11135, 0x11136),
    (0x11144, 0x11150), (0x11177, 0x11180), (0x111CE, 0x111D0), (0x111E0, 0x111E1),
    (0x111F5, 0x11200), (0x11212, 0x11213), (0x1123F, 0x11280), (0x11287, 0x11288),
    (0x11289, 0x1128A), (0x1128E, 0x1128F), (0x1129E, 0x1129F), (0x112AA, 0x112B0),
    (0x112EB, 0x112F0), (0x112FA, 0x11300), (0x11304, 0x11305), (0x1130D, 0x1130F),
    (0x11311, 0x11313), (0x11329, 0x1132A), (0x11331, 0x11332), (0x11334, 0x11335),
    (0x1133A, 0x1133C), (0x11345, 0x11347), (0x11349, 0x1134B), (0x1134E, 0x11350),
    (0x11351, 0x11357), (0x11358, 0x1135D), (0x11364, 0x11366), (0x1136D, 0x11370),
    (0x11375, 0x11400), (0x1145A, 0x1145B), (0x1145C, 0x1145D), (0x1145E, 0x11480),
    (0x114C8, 0x114D0), (0x114DA, 0x11580), (0x115B6, 0x115B8), (0x115DE, 0x11600),
    (0x11645, 0x11650), (0x1165A, 0x11660), (0x1166D, 0x11680), (0x116B8, 0x116C0),
    (0x116CA, 0x11700), (0x1171A, 0x1171D), (0x1172C, 0x11730), (0x11740, 0x118A0),
    (0x118F3, 0x118FF), (0x11900, 0x11AC0), (0x11AF9, 0x11C00), (0x11C09, 0x11C0A),
    (0x11C37, 0x11C38), (0x11C46, 0x11C50), (0x11C6D, 0x11C70), (0x11C90, 0x11C92),
    (0x11CA8, 0x11CA9), (0x11CB7, 0x12000), (0x1239A, 0x12400), (0x1246F, 0x12470),
    (0x12475, 0x12480), (0x12544, 0x13000), (0x1342F, 0x14400), (0x14647, 0x16800),
    (0x16A39, 0x16A40), (0x16A5F, 0x16A60), (0x16A6A, 0x16A6E), (0x16A70, 0x16AD0),
    (0x16AEE, 0x16AF0), (0x16AF6, 0x16B00), (0x16B46, 0x16B50), (0x16B5A, 0x16B5B),
    (0x16B62, 0x16B63), (0x16B78, 0x16B7D), (0x16B90, 0x16F00), (0x16F45, 0x16F50),
    (0x16F7F, 0x16F8F), (0x16FA0, 0x16FE0), (0x16FE1, 0x17000), (0x187ED, 0x18800),
    (0x18AF3, 0x1B000), (0x1B002, 0x1BC00), (0x1BC6B, 0x1BC70), (0x1BC7D, 0x1BC80),
    (0x1BC89, 0x1BC90), (0x1BC9A, 0x1BC9C), (0x1BCA4, 0x1D000), (0x1D0F6, 0x1D100),
    (0x1D127, 0x1D129), (0x1D1E9, 0x1D200), (0x1D246, 0x1D300), (0x1D357, 0x1D360),
    (0x1D372, 0x1D400), (0x1D455, 0x1D456), (0x1D49D, 0x1D49E), (0x1D4A0, 0x1D4A2),
    (0x1D4A3, 0x1D4A5), (0x1D4A7, 0x1D4A9), (0x1D4AD, 0x1D4AE), (0x1D4BA, 0x1D4BB),
    (0x1D4BC, 0x1D4BD), (0x1D4C4, 0x1D4C5), (0x1D506, 0x1D507), (0x1D50B, 0x1D50D),
    (0x1D515, 0x1D516), (0x1D51D, 0x1D51E), (0x1D53A, 0x1D53B), (0x1D53F, 0x1D540),
    (0x1D545, 0x1D546), (0x1D547, 0x1D54A), (0x1D551, 0x1D552), (0x1D6A6, 0x1D6A8),
    (0x1D7CC, 0x1D7CE), (0x1DA8C, 0x1DA9B), (0x1DAA0, 0x1DAA1), (0x1DAB0, 0x1E000),
    (0x1E007, 0x1E008), (0x1E019, 0x1E01B), (0x1E022, 0x1E023), (0x1E025, 0x1E026),
    (0x1E02B, 0x1E800), (0x1E8C5, 0x1E8C7), (0x1E8D7, 0x1E900), (0x1E94B, 0x1E950),
    (0x1E95A, 0x1E95E), (0x1E960, 0x1EE00), (0x1EE04, 0x1EE05), (0x1EE20, 0x1EE21),
    (0x1EE23, 0x1EE24), (0x1EE25, 0x1EE27), (0x1EE28, 0x1EE29), (0x1EE33, 0x1EE34),
    (0x1EE38, 0x1EE39), (0x1EE3A, 0x1EE3B), (0x1EE3C, 0x1EE42), (0x1EE43, 0x1EE47),
    (0x1EE48, 0x1EE49), (0x1EE4A, 0x1EE4B), (0x1EE4C, 0x1EE4D), (0x1EE50, 0x1EE51),
    (0x1EE53, 0x1EE54), (0x1EE55, 0x1EE57), (0x1EE58, 0x1EE59), (0x1EE5A, 0x1EE5B),
    (0x1EE5C, 0x1EE5D), (0x1EE5E, 0x1EE5F), (0x1EE60, 0x1EE61), (0x1EE63, 0x1EE64),
    (0x1EE65, 0x1EE67), (0x1EE6B, 0x1EE6C), (0x1EE73, 0x1EE74), (0x1EE78, 0x1EE79),
    (0x1EE7D, 0x1EE7E), (0x1EE7F, 0x1EE80), (0x1EE8A, 0x1EE8B), (0x1EE9C, 0x1EEA1),
    (0x1EEA4, 0x1EEA5), (0x1EEAA, 0x1EEAB), (0x1EEBC, 0x1EEF0), (0x1EEF2, 0x1F000),
    (0x1F02C, 0x1F030), (0x1F094, 0x1F0A0), (0x1F0AF, 0x1F0B1), (0x1F0C0, 0x1F0C1),
    (0x1F0D0, 0x1F0D1), (0x1F0F6, 0x1F100), (0x1F10D, 0x1F110), (0x1F12F, 0x1F130),
    (0x1F16C, 0x1F170), (0x1F1AD, 0x1F1E6), (0x1F203, 0x1F210), (0x1F23C, 0x1F240),
    (0x1F249, 0x1F250), (0x1F252, 0x1F300), (0x1F6D3, 0x1F6E0), (0x1F6ED, 0x1F6F0),
    (0x1F6F7, 0x1F700), (0x1F774, 0x1F780), (0x1F7D5, 0x1F800), (0x1F80C, 0x1F810),
    (0x1F848, 0x1F850), (0x1F85A, 0x1F860), (0x1F888, 0x1F890), (0x1F8AE, 0x1F910),
    (0x1F91F, 0x1F920), (0x1F928, 0x1F930), (0x1F931, 0x1F933), (0x1F93F, 0x1F940),
    (0x1F94C, 0x1F950), (0x1F95F, 0x1F980), (0x1F992, 0x1F9C0), (0x1F9C1, 0x20000),
    (0x2A6D7, 0x2A700), (0x2B735, 0x2B740), (0x2B81E, 0x2B820), (0x2CEA2, 0x2F800),
    (0x2FA1E, 0xE0001), (0xE0002, 0xE0020), (0xE0080, 0xE0100), (0xE01F0, 0xF0000),
    (0xFFFFE, 0x100000), (0x10FFFE, 0x110000),
  ),

  'Co': (
    (0xE000, 0xF900), (0xF0000, 0xFFFFE), (0x100000, 0x10FFFE),
  ),

  'Cs': (
    (0xD800, 0xE000),
  ),

  'Ll': (
    (0x0061, 0x007B), (0x00B5, 0x00B6), (0x00DF, 0x00F7), (0x00F8, 0x0100),
    (0x0101, 0x0102), (0x0103, 0x0104), (0x0105, 0x0106), (0x0107, 0x0108),
    (0x0109, 0x010A), (0x010B, 0x010C), (0x010D, 0x010E), (0x010F, 0x0110),
    (0x0111, 0x0112), (0x0113, 0x0114), (0x0115, 0x0116), (0x0117, 0x0118),
    (0x0119, 0x011A), (0x011B, 0x011C), (0x011D, 0x011E), (0x011F, 0x0120),
    (0x0121, 0x0122), (0x0123, 0x0124), (0x0125, 0x0126), (0x0127, 0x0128),
    (0x0129, 0x012A), (0x012B, 0x012C), (0x012D, 0x012E), (0x012F, 0x0130),
    (0x0131, 0x0132), (0x0133, 0x0134), (0x0135, 0x0136), (0x0137, 0x0139),
    (0x013A, 0x013B), (0x013C, 0x013D), (0x013E, 0x013F), (0x0140, 0x0141),
    (0x0142, 0x0143), (0x0144, 0x0145), (0x0146, 0x0147), (0x0148, 0x014A),
    (0x014B, 0x014C), (0x014D, 0x014E), (0x014F, 0x0150), (0x0151, 0x0152),
    (0x0153, 0x0154), (0x0155, 0x0156), (0x0157, 0x0158), (0x0159, 0x015A),
    (0x015B, 0x015C), (0x015D, 0x015E), (0x015F, 0x0160), (0x0161, 0x0162),
    (0x0163, 0x0164), (0x0165, 0x0166), (0x0167, 0x0168), (0x0169, 0x016A),
    (0x016B, 0x016C), (0x016D, 0x016E), (0x016F, 0x0170), (0x0171, 0x0172),
    (0x0173, 0x0174), (0x0175, 0x0176), (0x0177, 0x0178), (0x017A, 0x017B),
    (0x017C, 0x017D), (0x017E, 0x0181), (0x0183, 0x0184), (0x0185, 0x0186),
    (0x0188, 0x0189), (0x018C, 0x018E), (0x0192, 0x0193), (0x0195, 0x0196),
    (0x0199, 0x019C), (0x019E, 0x019F), (0x01A1, 0x01A2), (0x01A3, 0x01A4),
    (0x01A5, 0x01A6), (0x01A8, 0x01A9), (0x01AA, 0x01AC), (0x01AD, 0x01AE),
    (0x01B0, 0x01B1), (0x01B4, 0x01B5), (0x01B6, 0x01B7), (0x01B9, 0x01BB),
    (0x01BD, 0x01C0), (0x01C6, 0x01C7), (0x01C9, 0x01CA), (0x01CC, 0x01CD),
    (0x01CE, 0x01CF), (0x01D0, 0x01D1), (0x01D2, 0x01D3), (0x01D4, 0x01D5),
    (0x01D6, 0x01D7), (0x01D8, 0x01D9), (0x01DA, 0x01DB), (0x01DC, 0x01DE),
    (0x01DF, 0x01E0), (0x01E1, 0x01E2), (0x01E3, 0x01E4), (0x01E5, 0x01E6),
    (0x01E7, 0x01E8), (0x01E9, 0x01EA), (0x01EB, 0x01EC), (0x01ED, 0x01EE),
    (0x01EF, 0x01F1), (0x01F3, 0x01F4), (0x01F5, 0x01F6), (0x01F9, 0x01FA),
    (0x01FB, 0x01FC), (0x01FD, 0x01FE), (0x01FF, 0x0200), (0x0201, 0x0202),
    (0x0203, 0x0204), (0x0205, 0x0206), (0x0207, 0x0208), (0x0209, 0x020A),
    (0x020B, 0x020C), (0x020D, 0x020E), (0x020F, 0x0210), (0x0211, 0x0212),
    (0x0213, 0x0214), (0x0215, 0x0216), (0x0217, 0x0218), (0x0219, 0x021A),
    (0x021B, 0x021C), (0x021D, 0x021E), (0x021F, 0x0220), (0x0221, 0x0222),
    (0x0223, 0x0224), (0x0225, 0x0226), (0x0227, 0x0228), (0x0229, 0x022A),
    (0x022B, 0x022C), (0x022D, 0x022E), (0x022F, 0x0230), (0x0231, 0x0232),
    (0x0233, 0x023A), (0x023C, 0x023D), (0x023F, 0x0241), (0x0242, 0x0243),
    (0x0247, 0x0248), (0x0249, 0x024A), (0x024B, 0x024C), (0x024D, 0x024E),
    (0x024F, 0x0294), (0x0295, 0x02B0), (0x0371, 0x0372), (0x0373, 0x0374),
    (0x0377, 0x0378), (0x037B, 0x037E), (0x0390, 0x0391), (0x03AC, 0x03CF),
    (0x03D0, 0x03D2), (0x03D5, 0x03D8), (0x03D9, 0x03DA), (0x03DB, 0x03DC),
    (0x03DD, 0x03DE), (0x03DF, 0x03E0), (0x03E1, 0x03E2), (0x03E3, 0x03E4),
    (0x03E5, 0x03E6), (0x03E7, 0x03E8), (0x03E9, 0x03EA), (0x03EB, 0x03EC),
    (0x03ED, 0x03EE), (0x03EF, 0x03F4), (0x03F5, 0x03F6), (0x03F8, 0x03F9),
    (0x03FB, 0x03FD), (0x0430, 0x0460), (0x0461, 0x0462), (0x0463, 0x0464),
    (0x0465, 0x0466), (0x0467, 0x0468), (0x0469, 0x046A), (0x046B, 0x046C),
    (0x046D, 0x046E), (0x046F, 0x0470), (0x0471, 0x0472), (0x0473, 0x0474),
    (0x0475, 0x0476), (0x0477, 0x0478), (0x0479, 0x047A), (0x047B, 0x047C),
    (0x047D, 0x047E), (0x047F, 0x0480), (0x0481, 0x0482), (0x048B, 0x048C),
    (0x048D, 0x048E), (0x048F, 0x0490), (0x0491, 0x0492), (0x0493, 0x0494),
    (0x0495, 0x0496), (0x0497, 0x0498), (0x0499, 0x049A), (0x049B, 0x049C),
    (0x049D, 0x049E), (0x049F, 0x04A0), (0x04A1, 0x04A2), (0x04A3, 0x04A4),
    (0x04A5, 0x04A6), (0x04A7, 0x04A8), (0x04A9, 0x04AA), (0x04AB, 0x04AC),
    (0x04AD, 0x04AE), (0x04AF, 0x04B0), (0x04B1, 0x04B2), (0x04B3, 0x04B4),
    (0x04B5, 0x04B6), (0x04B7, 0x04B8), (0x04B9, 0x04BA), (0x04BB, 0x04BC),
    (0x04BD, 0x04BE), (0x04BF, 0x04C0), (0x04C2, 0x04C3), (0x04C4, 0x04C5),
    (0x04C6, 0x04C7), (0x04C8, 0x04C9), (0x04CA, 0x04CB), (0x04CC, 0x04CD),
    (0x04CE, 0x04D0), (0x04D1, 0x04D2), (0x04D3, 0x04D4), (0x04D5, 0x04D6),
    (0x04D7, 0x04D8), (0x04D9, 0x04DA), (0x04DB, 0x04DC), (0x04DD, 0x04DE),
    (0x04DF, 0x04E0), (0x04E1, 0x04E2), (0x04E3, 0x04E4), (0x04E5, 0x04E6),
    (0x04E7, 0x04E8), (0x04E9, 0x04EA), (0x04EB, 0x04EC), (0x04ED, 0x04EE),
    (0x04EF, 0x04F0), (0x04F1, 0x04F2), (0x04F3, 0x04F4), (0x04F5, 0x04F6),
    (0x04F7, 0x04F8), (0x04F9, 0x04FA), (0x04FB, 0x04FC), (0x04FD, 0x04FE),
    (0x04FF, 0x0500), (0x0501, 0x0502), (0x0503, 0x0504), (0x0505, 0x0506),
    (0x0507, 0x0508), (0x0509, 0x050A), (0x050B, 0x050C), (0x050D, 0x050E),
    (0x050F, 0x0510), (0x0511, 0x0512), (0x0513, 0x0514), (0x0515, 0x0516),
    (0x0517, 0x0518), (0x0519, 0x051A), (0x051B, 0x051C), (0x051D, 0x051E),
    (0x051F, 0x0520), (0x0521, 0x0522), (0x0523, 0x0524), (0x0525, 0x0526),
    (0x0527, 0x0528), (0x0529, 0x052A), (0x052B, 0x052C), (0x052D, 0x052E),
    (0x052F, 0x0530), (0x0561, 0x0588), (0x13F8, 0x13FE), (0x1C80, 0x1C89),
    (0x1D00, 0x1D2C), (0x1D6B, 0x1D78), (0x1D79, 0x1D9B), (0x1E01, 0x1E02),
    (0x1E03, 0x1E04), (0x1E05, 0x1E06), (0x1E07, 0x1E08), (0x1E09, 0x1E0A),
    (0x1E0B, 0x1E0C), (0x1E0D, 0x1E0E), (0x1E0F, 0x1E10), (0x1E11, 0x1E12),
    (0x1E13, 0x1E14), (0x1E15, 0x1E16), (0x1E17, 0x1E18), (0x1E19, 0x1E1A),
    (0x1E1B, 0x1E1C), (0x1E1D, 0x1E1E), (0x1E1F, 0x1E20), (0x1E21, 0x1E22),
    (0x1E23, 0x1E24), (0x1E25, 0x1E26), (0x1E27, 0x1E28), (0x1E29, 0x1E2A),
    (0x1E2B, 0x1E2C), (0x1E2D, 0x1E2E), (0x1E2F, 0x1E30), (0x1E31, 0x1E32),
    (0x1E33, 0x1E34), (0x1E35, 0x1E36), (0x1E37, 0x1E38), (0x1E39, 0x1E3A),
    (0x1E3B, 0x1E3C), (0x1E3D, 0x1E3E), (0x1E3F, 0x1E40), (0x1E41, 0x1E42),
    (0x1E43, 0x1E44), (0x1E45, 0x1E46), (0x1E47, 0x1E48), (0x1E49, 0x1E4A),
    (0x1E4B, 0x1E4C), (0x1E4D, 0x1E4E), (0x1E4F, 0x1E50), (0x1E51, 0x1E52),
    (0x1E53, 0x1E54), (0x1E55, 0x1E56), (0x1E57, 0x1E58), (0x1E59, 0x1E5A),
    (0x1E5B, 0x1E5C), (0x1E5D, 0x1E5E), (0x1E5F, 0x1E60), (0x1E61, 0x1E62),
    (0x1E63, 0x1E64), (0x1E65, 0x1E66), (0x1E67, 0x1E68), (0x1E69, 0x1E6A),
    (0x1E6B, 0x1E6C), (0x1E6D, 0x1E6E), (0x1E6F, 0x1E70), (0x1E71, 0x1E72),
    (0x1E73, 0x1E74), (0x1E75, 0x1E76), (0x1E77, 0x1E78), (0x1E79, 0x1E7A),
    (0x1E7B, 0x1E7C), (0x1E7D, 0x1E7E), (0x1E7F, 0x1E80), (0x1E81, 0x1E82),
    (0x1E83, 0x1E84), (0x1E85, 0x1E86), (0x1E87, 0x1E88), (0x1E89, 0x1E8A),
    (0x1E8B, 0x1E8C), (0x1E8D, 0x1E8E), (0x1E8F, 0x1E90), (0x1E91, 0x1E92),
    (0x1E93, 0x1E94), (0x1E95, 0x1E9E), (0x1E9F, 0x1EA0), (0x1EA1, 0x1EA2),
    (0x1EA3, 0x1EA4), (0x1EA5, 0x1EA6), (0x1EA7, 0x1EA8), (0x1EA9, 0x1EAA),
    (0x1EAB, 0x1EAC), (0x1EAD, 0x1EAE), (0x1EAF, 0x1EB0), (0x1EB1, 0x1EB2),
    (0x1EB3, 0x1EB4), (0x1EB5, 0x1EB6), (0x1EB7, 0x1EB8), (0x1EB9, 0x1EBA),
    (0x1EBB, 0x1EBC), (0x1EBD, 0x1EBE), (0x1EBF, 0x1EC0), (0x1EC1, 0x1EC2),
    (0x1EC3, 0x1EC4), (0x1EC5, 0x1EC6), (0x1EC7, 0x1EC8), (0x1EC9, 0x1ECA),
    (0x1ECB, 0x1ECC), (0x1ECD, 0x1ECE), (0x1ECF, 0x1ED0), (0x1ED1, 0x1ED2),
    (0x1ED3, 0x1ED4), (0x1ED5, 0x1ED6), (0x1ED7, 0x1ED8), (0x1ED9, 0x1EDA),
    (0x1EDB, 0x1EDC), (0x1EDD, 0x1EDE), (0x1EDF, 0x1EE0), (0x1EE1, 0x1EE2),
    (0x1EE3, 0x1EE4), (0x1EE5, 0x1EE6), (0x1EE7, 0x1EE8), (0x1EE9, 0x1EEA),
    (0x1EEB, 0x1EEC), (0x1EED, 0x1EEE), (0x1EEF, 0x1EF0), (0x1EF1, 0x1EF2),
    (0x1EF3, 0x1EF4), (0x1EF5, 0x1EF6), (0x1EF7, 0x1EF8), (0x1EF9, 0x1EFA),
    (0x1EFB, 0x1EFC), (0x1EFD, 0x1EFE), (0x1EFF, 0x1F08), (0x1F10, 0x1F16),
    (0x1F20, 0x1F28), (0x1F30, 0x1F38), (0x1F40, 0x1F46), (0x1F50, 0x1F58),
    (0x1F60, 0x1F68), (0x1F70, 0x1F7E), (0x1F80, 0x1F88), (0x1F90, 0x1F98),
    (0x1FA0, 0x1FA8), (0x1FB0, 0x1FB5), (0x1FB6, 0x1FB8), (0x1FBE, 0x1FBF),
    (0x1FC2, 0x1FC5), (0x1FC6, 0x1FC8), (0x1FD0, 0x1FD4), (0x1FD6, 0x1FD8),
    (0x1FE0, 0x1FE8), (0x1FF2, 0x1FF5), (0x1FF6, 0x1FF8), (0x210A, 0x210B),
    (0x210E, 0x2110), (0x2113, 0x2114), (0x212F, 0x2130), (0x2134, 0x2135),
    (0x2139, 0x213A), (0x213C, 0x213E), (0x2146, 0x214A), (0x214E, 0x214F),
    (0x2184, 0x2185), (0x2C30, 0x2C5F), (0x2C61, 0x2C62), (0x2C65, 0x2C67),
    (0x2C68, 0x2C69), (0x2C6A, 0x2C6B), (0x2C6C, 0x2C6D), (0x2C71, 0x2C72),
    (0x2C73, 0x2C75), (0x2C76, 0x2C7C), (0x2C81, 0x2C82), (0x2C83, 0x2C84),
    (0x2C85, 0x2C86), (0x2C87, 0x2C88), (0x2C89, 0x2C8A), (0x2C8B, 0x2C8C),
    (0x2C8D, 0x2C8E), (0x2C8F, 0x2C90), (0x2C91, 0x2C92), (0x2C93, 0x2C94),
    (0x2C95, 0x2C96), (0x2C97, 0x2C98), (0x2C99, 0x2C9A), (0x2C9B, 0x2C9C),
    (0x2C9D, 0x2C9E), (0x2C9F, 0x2CA0), (0x2CA1, 0x2CA2), (0x2CA3, 0x2CA4),
    (0x2CA5, 0x2CA6), (0x2CA7, 0x2CA8), (0x2CA9, 0x2CAA), (0x2CAB, 0x2CAC),
    (0x2CAD, 0x2CAE), (0x2CAF, 0x2CB0), (0x2CB1, 0x2CB2), (0x2CB3, 0x2CB4),
    (0x2CB5, 0x2CB6), (0x2CB7, 0x2CB8), (0x2CB9, 0x2CBA), (0x2CBB, 0x2CBC),
    (0x2CBD, 0x2CBE), (0x2CBF, 0x2CC0), (0x2CC1, 0x2CC2), (0x2CC3, 0x2CC4),
    (0x2CC5, 0x2CC6), (0x2CC7, 0x2CC8), (0x2CC9, 0x2CCA), (0x2CCB, 0x2CCC),
    (0x2CCD, 0x2CCE), (0x2CCF, 0x2CD0), (0x2CD1, 0x2CD2), (0x2CD3, 0x2CD4),
    (0x2CD5, 0x2CD6), (0x2CD7, 0x2CD8), (0x2CD9, 0x2CDA), (0x2CDB, 0x2CDC),
    (0x2CDD, 0x2CDE), (0x2CDF, 0x2CE0), (0x2CE1, 0x2CE2), (0x2CE3, 0x2CE5),
    (0x2CEC, 0x2CED), (0x2CEE, 0x2CEF), (0x2CF3, 0x2CF4), (0x2D00, 0x2D26),
    (0x2D27, 0x2D28), (0x2D2D, 0x2D2E), (0xA641, 0xA642), (0xA643, 0xA644),
    (0xA645, 0xA646), (0xA647, 0xA648), (0xA649, 0xA64A), (0xA64B, 0xA64C),
    (0xA64D, 0xA64E), (0xA64F, 0xA650), (0xA651, 0xA652), (0xA653, 0xA654),
    (0xA655, 0xA656), (0xA657, 0xA658), (0xA659, 0xA65A), (0xA65B, 0xA65C),
    (0xA65D, 0xA65E), (0xA65F, 0xA660), (0xA661, 0xA662), (0xA663, 0xA664),
    (0xA665, 0xA666), (0xA667, 0xA668), (0xA669, 0xA66A), (0xA66B, 0xA66C),
    (0xA66D, 0xA66E), (0xA681, 0xA682), (0xA683, 0xA684), (0xA685, 0xA686),
    (0xA687, 0xA688), (0xA689, 0xA68A), (0xA68B, 0xA68C), (0xA68D, 0xA68E),
    (0xA68F, 0xA690), (0xA691, 0xA692), (0xA693, 0xA694), (0xA695, 0xA696),
    (0xA697, 0xA698), (0xA699, 0xA69A), (0xA69B, 0xA69C), (0xA723, 0xA724),
    (0xA725, 0xA726), (0xA727, 0xA728), (0xA729, 0xA72A), (0xA72B, 0xA72C),
    (0xA72D, 0xA72E), (0xA72F, 0xA732), (0xA733, 0xA734), (0xA735, 0xA736),
    (0xA737, 0xA738), (0xA739, 0xA73A), (0xA73B, 0xA73C), (0xA73D, 0xA73E),
    (0xA73F, 0xA740), (0xA741, 0xA742), (0xA743, 0xA744), (0xA745, 0xA746),
    (0xA747, 0xA748), (0xA749, 0xA74A), (0xA74B, 0xA74C), (0xA74D, 0xA74E),
    (0xA74F, 0xA750), (0xA751, 0xA752), (0xA753, 0xA754), (0xA755, 0xA756),
    (0xA757, 0xA758), (0xA759, 0xA75A), (0xA75B, 0xA75C), (0xA75D, 0xA75E),
    (0xA75F, 0xA760), (0xA761, 0xA762), (0xA763, 0xA764), (0xA765, 0xA766),
    (0xA767, 0xA768), (0xA769, 0xA76A), (0xA76B, 0xA76C), (0xA76D, 0xA76E),
    (0xA76F, 0xA770), (0xA771, 0xA779), (0xA77A, 0xA77B), (0xA77C, 0xA77D),
    (0xA77F, 0xA780), (0xA781, 0xA782), (0xA783, 0xA784), (0xA785, 0xA786),
    (0xA787, 0xA788), (0xA78C, 0xA78D), (0xA78E, 0xA78F), (0xA791, 0xA792),
    (0xA793, 0xA796), (0xA797, 0xA798), (0xA799, 0xA79A), (0xA79B, 0xA79C),
    (0xA79D, 0xA79E), (0xA79F, 0xA7A0), (0xA7A1, 0xA7A2), (0xA7A3, 0xA7A4),
    (0xA7A5, 0xA7A6), (0xA7A7, 0xA7A8), (0xA7A9, 0xA7AA), (0xA7B5, 0xA7B6),
    (0xA7B7, 0xA7B8), (0xA7FA, 0xA7FB), (0xAB30, 0xAB5B), (0xAB60, 0xAB66),
    (0xAB70, 0xABC0), (0xFB00, 0xFB07), (0xFB13, 0xFB18), (0xFF41, 0xFF5B),
    (0x10428, 0x10450), (0x104D8, 0x104FC), (0x10CC0, 0x10CF3), (0x118C0, 0x118E0),
    (0x1D41A, 0x1D434), (0x1D44E, 0x1D455), (0x1D456, 0x1D468), (0x1D482, 0x1D49C),
    (0x1D4B6, 0x1D4BA), (0x1D4BB, 0x1D4BC), (0x1D4BD, 0x1D4C4), (0x1D4C5, 0x1D4D0),
    (0x1D4EA, 0x1D504), (0x1D51E, 0x1D538), (0x1D552, 0x1D56C), (0x1D586, 0x1D5A0),
    (0x1D5BA, 0x1D5D4), (0x1D5EE, 0x1D608), (0x1D622, 0x1D63C), (0x1D656, 0x1D670),
    (0x1D68A, 0x1D6A6), (0x1D6C2, 0x1D6DB), (0x1D6DC, 0x1D6E2), (0x1D6FC, 0x1D715),
    (0x1D716, 0x1D71C), (0x1D736, 0x1D74F), (0x1D750, 0x1D756), (0x1D770, 0x1D789),
    (0x1D78A, 0x1D790), (0x1D7AA, 0x1D7C3), (0x1D7C4, 0x1D7CA), (0x1D7CB, 0x1D7CC),
    (0x1E922, 0x1E944),
  ),

  'Lm': (
    (0x02B0, 0x02C2), (0x02C6, 0x02D2), (0x02E0, 0x02E5), (0x02EC, 0x02ED),
    (0x02EE, 0x02EF), (0x0374, 0x0375), (0x037A, 0x037B), (0x0559, 0x055A),
    (0x0640, 0x0641), (0x06E5, 0x06E7), (0x07F4, 0x07F6), (0x07FA, 0x07FB),
    (0x081A, 0x081B), (0x0824, 0x0825), (0x0828, 0x0829), (0x0971, 0x0972),
    (0x0E46, 0x0E47), (0x0EC6, 0x0EC7), (0x10FC, 0x10FD), (0x17D7, 0x17D8),
    (0x1843, 0x1844), (0x1AA7, 0x1AA8), (0x1C78, 0x1C7E), (0x1D2C, 0x1D6B),
    (0x1D78, 0x1D79), (0x1D9B, 0x1DC0), (0x2071, 0x2072), (0x207F, 0x2080),
    (0x2090, 0x209D), (0x2C7C, 0x2C7E), (0x2D6F, 0x2D70), (0x2E2F, 0x2E30),
    (0x3005, 0x3006), (0x3031, 0x3036), (0x303B, 0x303C), (0x309D, 0x309F),
    (0x30FC, 0x30FF), (0xA015, 0xA016), (0xA4F8, 0xA4FE), (0xA60C, 0xA60D),
    (0xA67F, 0xA680), (0xA69C, 0xA69E), (0xA717, 0xA720), (0xA770, 0xA771),
    (0xA788, 0xA789), (0xA7F8, 0xA7FA), (0xA9CF, 0xA9D0), (0xA9E6, 0xA9E7),
    (0xAA70, 0xAA71), (0xAADD, 0xAADE), (0xAAF3, 0xAAF5), (0xAB5C, 0xAB60),
    (0xFF70, 0xFF71), (0xFF9E, 0xFFA0), (0x16B40, 0x16B44), (0x16F93, 0x16FA0),
    (0x16FE0, 0x16FE1),
  ),

  'Lo': (
    (0x00AA, 0x00AB), (0x00BA, 0x00BB), (0x01BB, 0x01BC), (0x01C0, 0x01C4),
    (0x0294, 0x0295), (0x05D0, 0x05EB), (0x05F0, 0x05F3), (0x0620, 0x0640),
    (0x0641, 0x064B), (0x066E, 0x0670), (0x0671, 0x06D4), (0x06D5, 0x06D6),
    (0x06EE, 0x06F0), (0x06FA, 0x06FD), (0x06FF, 0x0700), (0x0710, 0x0711),
    (0x0712, 0x0730), (0x074D, 0x07A6), (0x07B1, 0x07B2), (0x07CA, 0x07EB),
    (0x0800, 0x0816), (0x0840, 0x0859), (0x08A0, 0x08B5), (0x08B6, 0x08BE),
    (0x0904, 0x093A), (0x093D, 0x093E), (0x0950, 0x0951), (0x0958, 0x0962),
    (0x0972, 0x0981), (0x0985, 0x098D), (0x098F, 0x0991), (0x0993, 0x09A9),
    (0x09AA, 0x09B1), (0x09B2, 0x09B3), (0x09B6, 0x09BA), (0x09BD, 0x09BE),
    (0x09CE, 0x09CF), (0x09DC, 0x09DE), (0x09DF, 0x09E2), (0x09F0, 0x09F2),
    (0x0A05, 0x0A0B), (0x0A0F, 0x0A11), (0x0A13, 0x0A29), (0x0A2A, 0x0A31),
    (0x0A32, 0x0A34), (0x0A35, 0x0A37), (0x0A38, 0x0A3A), (0x0A59, 0x0A5D),
    (0x0A5E, 0x0A5F), (0x0A72, 0x0A75), (0x0A85, 0x0A8E), (0x0A8F, 0x0A92),
    (0x0A93, 0x0AA9), (0x0AAA, 0x0AB1), (0x0AB2, 0x0AB4), (0x0AB5, 0x0ABA),
    (0x0ABD, 0x0ABE), (0x0AD0, 0x0AD1), (0x0AE0, 0x0AE2), (0x0AF9, 0x0AFA),
    (0x0B05, 0x0B0D), (0x0B0F, 0x0B11), (0x0B13, 0x0B29), (0x0B2A, 0x0B31),
    (0x0B32, 0x0B34), (0x0B35, 0x0B3A), (0x0B3D, 0x0B3E), (0x0B5C, 0x0B5E),
    (0x0B5F, 0x0B62), (0x0B71, 0x0B72), (0x0B83, 0x0B84), (0x0B85, 0x0B8B),
    (0x0B8E, 0x0B91), (0x0B92, 0x0B96), (0x0B99, 0x0B9B), (0x0B9C, 0x0B9D),
    (0x0B9E, 0x0BA0), (0x0BA3, 0x0BA5), (0x0BA8, 0x0BAB), (0x0BAE, 0x0BBA),
    (0x0BD0, 0x0BD1), (0x0C05, 0x0C0D), (0x0C0E, 0x0C11), (0x0C12, 0x0C29),
    (0x0C2A, 0x0C3A), (0x0C3D, 0x0C3E), (0x0C58, 0x0C5B), (0x0C60, 0x0C62),
    (0x0C80, 0x0C81), (0x0C85, 0x0C8D), (0x0C8E, 0x0C91), (0x0C92, 0x0CA9),
    (0x0CAA, 0x0CB4), (0x0CB5, 0x0CBA), (0x0CBD, 0x0CBE), (0x0CDE, 0x0CDF),
    (0x0CE0, 0x0CE2), (0x0CF1, 0x0CF3), (0x0D05, 0x0D0D), (0x0D0E, 0x0D11),
    (0x0D12, 0x0D3B), (0x0D3D, 0x0D3E), (0x0D4E, 0x0D4F), (0x0D54, 0x0D57),
    (0x0D5F, 0x0D62), (0x0D7A, 0x0D80), (0x0D85, 0x0D97), (0x0D9A, 0x0DB2),
    (0x0DB3, 0x0DBC), (0x0DBD, 0x0DBE), (0x0DC0, 0x0DC7), (0x0E01, 0x0E31),
    (0x0E32, 0x0E34), (0x0E40, 0x0E46), (0x0E81, 0x0E83), (0x0E84, 0x0E85),
    (0x0E87, 0x0E89), (0x0E8A, 0x0E8B), (0x0E8D, 0x0E8E), (0x0E94, 0x0E98),
    (0x0E99, 0x0EA0), (0x0EA1, 0x0EA4), (0x0EA5, 0x0EA6), (0x0EA7, 0x0EA8),
    (0x0EAA, 0x0EAC), (0x0EAD, 0x0EB1), (0x0EB2, 0x0EB4), (0x0EBD, 0x0EBE),
    (0x0EC0, 0x0EC5), (0x0EDC, 0x0EE0), (0x0F00, 0x0F01), (0x0F40, 0x0F48),
    (0x0F49, 0x0F6D), (0x0F88, 0x0F8D), (0x1000, 0x102B), (0x103F, 0x1040),
    (0x1050, 0x1056), (0x105A, 0x105E), (0x1061, 0x1062), (0x1065, 0x1067),
    (0x106E, 0x1071), (0x1075, 0x1082), (0x108E, 0x108F), (0x10D0, 0x10FB),
    (0x10FD, 0x1249), (0x124A, 0x124E), (0x1250, 0x1257), (0x1258, 0x1259),
    (0x125A, 0x125E), (0x1260, 0x1289), (0x128A, 0x128E), (0x1290, 0x12B1),
    (0x12B2, 0x12B6), (0x12B8, 0x12BF), (0x12C0, 0x12C1), (0x12C2, 0x12C6),
    (0x12C8, 0x12D7), (0x12D8, 0x1311), (0x1312, 0x1316), (0x1318, 0x135B),
    (0x1380, 0x1390), (0x1401, 0x166D), (0x166F, 0x1680), (0x1681, 0x169B),
    (0x16A0, 0x16EB), (0x16F1, 0x16F9), (0x1700, 0x170D), (0x170E, 0x1712),
    (0x1720, 0x1732), (0x1740, 0x1752), (0x1760, 0x176D), (0x176E, 0x1771),
    (0x1780, 0x17B4), (0x17DC, 0x17DD), (0x1820, 0x1843), (0x1844, 0x1878),
    (0x1880, 0x1885), (0x1887, 0x18A9), (0x18AA, 0x18AB), (0x18B0, 0x18F6),
    (0x1900, 0x191F), (0x1950, 0x196E), (0x1970, 0x1975), (0x1980, 0x19AC),
    (0x19B0, 0x19CA), (0x1A00, 0x1A17), (0x1A20, 0x1A55), (0x1B05, 0x1B34),
    (0x1B45, 0x1B4C), (0x1B83, 0x1BA1), (0x1BAE, 0x1BB0), (0x1BBA, 0x1BE6),
    (0x1C00, 0x1C24), (0x1C4D, 0x1C50), (0x1C5A, 0x1C78), (0x1CE9, 0x1CED),
    (0x1CEE, 0x1CF2), (0x1CF5, 0x1CF7), (0x2135, 0x2139), (0x2D30, 0x2D68),
    (0x2D80, 0x2D97), (0x2DA0, 0x2DA7), (0x2DA8, 0x2DAF), (0x2DB0, 0x2DB7),
    (0x2DB8, 0x2DBF), (0x2DC0, 0x2DC7), (0x2DC8, 0x2DCF), (0x2DD0, 0x2DD7),
    (0x2DD8, 0x2DDF), (0x3006, 0x3007), (0x303C, 0x303D), (0x3041, 0x3097),
    (0x309F, 0x30A0), (0x30A1, 0x30FB), (0x30FF, 0x3100), (0x3105, 0x312E),
    (0x3131, 0x318F), (0x31A0, 0x31BB), (0x31F0, 0x3200), (0x3400, 0x4DB6),
    (0x4E00, 0x9FD6), (0xA000, 0xA015), (0xA016, 0xA48D), (0xA4D0, 0xA4F8),
    (0xA500, 0xA60C), (0xA610, 0xA620), (0xA62A, 0xA62C), (0xA66E, 0xA66F),
    (0xA6A0, 0xA6E6), (0xA78F, 0xA790), (0xA7F7, 0xA7F8), (0xA7FB, 0xA802),
    (0xA803, 0xA806), (0xA807, 0xA80B), (0xA80C, 0xA823), (0xA840, 0xA874),
    (0xA882, 0xA8B4), (0xA8F2, 0xA8F8), (0xA8FB, 0xA8FC), (0xA8FD, 0xA8FE),
    (0xA90A, 0xA926), (0xA930, 0xA947), (0xA960, 0xA97D), (0xA984, 0xA9B3),
    (0xA9E0, 0xA9E5), (0xA9E7, 0xA9F0), (0xA9FA, 0xA9FF), (0xAA00, 0xAA29),
    (0xAA40, 0xAA43), (0xAA44, 0xAA4C), (0xAA60, 0xAA70), (0xAA71, 0xAA77),
    (0xAA7A, 0xAA7B), (0xAA7E, 0xAAB0), (0xAAB1, 0xAAB2), (0xAAB5, 0xAAB7),
    (0xAAB9, 0xAABE), (0xAAC0, 0xAAC1), (0xAAC2, 0xAAC3), (0xAADB, 0xAADD),
    (0xAAE0, 0xAAEB), (0xAAF2, 0xAAF3), (0xAB01, 0xAB07), (0xAB09, 0xAB0F),
    (0xAB11, 0xAB17), (0xAB20, 0xAB27), (0xAB28, 0xAB2F), (0xABC0, 0xABE3),
    (0xAC00, 0xD7A4), (0xD7B0, 0xD7C7), (0xD7CB, 0xD7FC), (0xF900, 0xFA6E),
    (0xFA70, 0xFADA), (0xFB1D, 0xFB1E), (0xFB1F, 0xFB29), (0xFB2A, 0xFB37),
    (0xFB38, 0xFB3D), (0xFB3E, 0xFB3F), (0xFB40, 0xFB42), (0xFB43, 0xFB45),
    (0xFB46, 0xFBB2), (0xFBD3, 0xFD3E), (0xFD50, 0xFD90), (0xFD92, 0xFDC8),
    (0xFDF0, 0xFDFC), (0xFE70, 0xFE75), (0xFE76, 0xFEFD), (0xFF66, 0xFF70),
    (0xFF71, 0xFF9E), (0xFFA0, 0xFFBF), (0xFFC2, 0xFFC8), (0xFFCA, 0xFFD0),
    (0xFFD2, 0xFFD8), (0xFFDA, 0xFFDD), (0x10000, 0x1000C), (0x1000D, 0x10027),
    (0x10028, 0x1003B), (0x1003C, 0x1003E), (0x1003F, 0x1004E), (0x10050, 0x1005E),
    (0x10080, 0x100FB), (0x10280, 0x1029D), (0x102A0, 0x102D1), (0x10300, 0x10320),
    (0x10330, 0x10341), (0x10342, 0x1034A), (0x10350, 0x10376), (0x10380, 0x1039E),
    (0x103A0, 0x103C4), (0x103C8, 0x103D0), (0x10450, 0x1049E), (0x10500, 0x10528),
    (0x10530, 0x10564), (0x10600, 0x10737), (0x10740, 0x10756), (0x10760, 0x10768),
    (0x10800, 0x10806), (0x10808, 0x10809), (0x1080A, 0x10836), (0x10837, 0x10839),
    (0x1083C, 0x1083D), (0x1083F, 0x10856), (0x10860, 0x10877), (0x10880, 0x1089F),
    (0x108E0, 0x108F3), (0x108F4, 0x108F6), (0x10900, 0x10916), (0x10920, 0x1093A),
    (0x10980, 0x109B8), (0x109BE, 0x109C0), (0x10A00, 0x10A01), (0x10A10, 0x10A14),
    (0x10A15, 0x10A18), (0x10A19, 0x10A34), (0x10A60, 0x10A7D), (0x10A80, 0x10A9D),
    (0x10AC0, 0x10AC8), (0x10AC9, 0x10AE5), (0x10B00, 0x10B36), (0x10B40, 0x10B56),
    (0x10B60, 0x10B73), (0x10B80, 0x10B92), (0x10C00, 0x10C49), (0x11003, 0x11038),
    (0x11083, 0x110B0), (0x110D0, 0x110E9), (0x11103, 0x11127), (0x11150, 0x11173),
    (0x11176, 0x11177), (0x11183, 0x111B3), (0x111C1, 0x111C5), (0x111DA, 0x111DB),
    (0x111DC, 0x111DD), (0x11200, 0x11212), (0x11213, 0x1122C), (0x11280, 0x11287),
    (0x11288, 0x11289), (0x1128A, 0x1128E), (0x1128F, 0x1129E), (0x1129F, 0x112A9),
    (0x112B0, 0x112DF), (0x11305, 0x1130D), (0x1130F, 0x11311), (0x11313, 0x11329),
    (0x1132A, 0x11331), (0x11332, 0x11334), (0x11335, 0x1133A), (0x1133D, 0x1133E),
    (0x11350, 0x11351), (0x1135D, 0x11362), (0x11400, 0x11435), (0x11447, 0x1144B),
    (0x11480, 0x114B0), (0x114C4, 0x114C6), (0x114C7, 0x114C8), (0x11580, 0x115AF),
    (0x115D8, 0x115DC), (0x11600, 0x11630), (0x11644, 0x11645), (0x11680, 0x116AB),
    (0x11700, 0x1171A), (0x118FF, 0x11900), (0x11AC0, 0x11AF9), (0x11C00, 0x11C09),
    (0x11C0A, 0x11C2F), (0x11C40, 0x11C41), (0x11C72, 0x11C90), (0x12000, 0x1239A),
    (0x12480, 0x12544), (0x13000, 0x1342F), (0x14400, 0x14647), (0x16800, 0x16A39),
    (0x16A40, 0x16A5F), (0x16AD0, 0x16AEE), (0x16B00, 0x16B30), (0x16B63, 0x16B78),
    (0x16B7D, 0x16B90), (0x16F00, 0x16F45), (0x16F50, 0x16F51), (0x17000, 0x187ED),
    (0x18800, 0x18AF3), (0x1B000, 0x1B002), (0x1BC00, 0x1BC6B), (0x1BC70, 0x1BC7D),
    (0x1BC80, 0x1BC89), (0x1BC90, 0x1BC9A), (0x1E800, 0x1E8C5), (0x1EE00, 0x1EE04),
    (0x1EE05, 0x1EE20), (0x1EE21, 0x1EE23), (0x1EE24, 0x1EE25), (0x1EE27, 0x1EE28),
    (0x1EE29, 0x1EE33), (0x1EE34, 0x1EE38), (0x1EE39, 0x1EE3A), (0x1EE3B, 0x1EE3C),
    (0x1EE42, 0x1EE43), (0x1EE47, 0x1EE48), (0x1EE49, 0x1EE4A), (0x1EE4B, 0x1EE4C),
    (0x1EE4D, 0x1EE50), (0x1EE51, 0x1EE53), (0x1EE54, 0x1EE55), (0x1EE57, 0x1EE58),
    (0x1EE59, 0x1EE5A), (0x1EE5B, 0x1EE5C), (0x1EE5D, 0x1EE5E), (0x1EE5F, 0x1EE60),
    (0x1EE61, 0x1EE63), (0x1EE64, 0x1EE65), (0x1EE67, 0x1EE6B), (0x1EE6C, 0x1EE73),
    (0x1EE74, 0x1EE78), (0x1EE79, 0x1EE7D), (0x1EE7E, 0x1EE7F), (0x1EE80, 0x1EE8A),
    (0x1EE8B, 0x1EE9C), (0x1EEA1, 0x1EEA4), (0x1EEA5, 0x1EEAA), (0x1EEAB, 0x1EEBC),
    (0x20000, 0x2A6D7), (0x2A700, 0x2B735), (0x2B740, 0x2B81E), (0x2B820, 0x2CEA2),
    (0x2F800, 0x2FA1E),
  ),

  'Lt': (
    (0x01C5, 0x01C6), (0x01C8, 0x01C9), (0x01CB, 0x01CC), (0x01F2, 0x01F3),
    (0x1F88, 0x1F90), (0x1F98, 0x1FA0), (0x1FA8, 0x1FB0), (0x1FBC, 0x1FBD),
    (0x1FCC, 0x1FCD), (0x1FFC, 0x1FFD),
  ),

  'Lu': (
    (0x0041, 0x005B), (0x00C0, 0x00D7), (0x00D8, 0x00DF), (0x0100, 0x0101),
    (0x0102, 0x0103), (0x0104, 0x0105), (0x0106, 0x0107), (0x0108, 0x0109),
    (0x010A, 0x010B), (0x010C, 0x010D), (0x010E, 0x010F), (0x0110, 0x0111),
    (0x0112, 0x0113), (0x0114, 0x0115), (0x0116, 0x0117), (0x0118, 0x0119),
    (0x011A, 0x011B), (0x011C, 0x011D), (0x011E, 0x011F), (0x0120, 0x0121),
    (0x0122, 0x0123), (0x0124, 0x0125), (0x0126, 0x0127), (0x0128, 0x0129),
    (0x012A, 0x012B), (0x012C, 0x012D), (0x012E, 0x012F), (0x0130, 0x0131),
    (0x0132, 0x0133), (0x0134, 0x0135), (0x0136, 0x0137), (0x0139, 0x013A),
    (0x013B, 0x013C), (0x013D, 0x013E), (0x013F, 0x0140), (0x0141, 0x0142),
    (0x0143, 0x0144), (0x0145, 0x0146), (0x0147, 0x0148), (0x014A, 0x014B),
    (0x014C, 0x014D), (0x014E, 0x014F), (0x0150, 0x0151), (0x0152, 0x0153),
    (0x0154, 0x0155), (0x0156, 0x0157), (0x0158, 0x0159), (0x015A, 0x015B),
    (0x015C, 0x015D), (0x015E, 0x015F), (0x0160, 0x0161), (0x0162, 0x0163),
    (0x0164, 0x0165), (0x0166, 0x0167), (0x0168, 0x0169), (0x016A, 0x016B),
    (0x016C, 0x016D), (0x016E, 0x016F), (0x0170, 0x0171), (0x0172, 0x0173),
    (0x0174, 0x0175), (0x0176, 0x0177), (0x0178, 0x017A), (0x017B, 0x017C),
    (0x017D, 0x017E), (0x0181, 0x0183), (0x0184, 0x0185), (0x0186, 0x0188),
    (0x0189, 0x018C), (0x018E, 0x0192), (0x0193, 0x0195), (0x0196, 0x0199),
    (0x019C, 0x019E), (0x019F, 0x01A1), (0x01A2, 0x01A3), (0x01A4, 0x01A5),
    (0x01A6, 0x01A8), (0x01A9, 0x01AA), (0x01AC, 0x01AD), (0x01AE, 0x01B0),
    (0x01B1, 0x01B4), (0x01B5, 0x01B6), (0x01B7, 0x01B9), (0x01BC, 0x01BD),
    (0x01C4, 0x01C5), (0x01C7, 0x01C8), (0x01CA, 0x01CB), (0x01CD, 0x01CE),
    (0x01CF, 0x01D0), (0x01D1, 0x01D2), (0x01D3, 0x01D4), (0x01D5, 0x01D6),
    (0x01D7, 0x01D8), (0x01D9, 0x01DA), (0x01DB, 0x01DC), (0x01DE, 0x01DF),
    (0x01E0, 0x01E1), (0x01E2, 0x01E3), (0x01E4, 0x01E5), (0x01E6, 0x01E7),
    (0x01E8, 0x01E9), (0x01EA, 0x01EB), (0x01EC, 0x01ED), (0x01EE, 0x01EF),
    (0x01F1, 0x01F2), (0x01F4, 0x01F5), (0x01F6, 0x01F9), (0x01FA, 0x01FB),
    (0x01FC, 0x01FD), (0x01FE, 0x01FF), (0x0200, 0x0201), (0x0202, 0x0203),
    (0x0204, 0x0205), (0x0206, 0x0207), (0x0208, 0x0209), (0x020A, 0x020B),
    (0x020C, 0x020D), (0x020E, 0x020F), (0x0210, 0x0211), (0x0212, 0x0213),
    (0x0214, 0x0215), (0x0216, 0x0217), (0x0218, 0x0219), (0x021A, 0x021B),
    (0x021C, 0x021D), (0x021E, 0x021F), (0x0220, 0x0221), (0x0222, 0x0223),
    (0x0224, 0x0225), (0x0226, 0x0227), (0x0228, 0x0229), (0x022A, 0x022B),
    (0x022C, 0x022D), (0x022E, 0x022F), (0x0230, 0x0231), (0x0232, 0x0233),
    (0x023A, 0x023C), (0x023D, 0x023F), (0x0241, 0x0242), (0x0243, 0x0247),
    (0x0248, 0x0249), (0x024A, 0x024B), (0x024C, 0x024D), (0x024E, 0x024F),
    (0x0370, 0x0371), (0x0372, 0x0373), (0x0376, 0x0377), (0x037F, 0x0380),
    (0x0386, 0x0387), (0x0388, 0x038B), (0x038C, 0x038D), (0x038E, 0x0390),
    (0x0391, 0x03A2), (0x03A3, 0x03AC), (0x03CF, 0x03D0), (0x03D2, 0x03D5),
    (0x03D8, 0x03D9), (0x03DA, 0x03DB), (0x03DC, 0x03DD), (0x03DE, 0x03DF),
    (0x03E0, 0x03E1), (0x03E2, 0x03E3), (0x03E4, 0x03E5), (0x03E6, 0x03E7),
    (0x03E8, 0x03E9), (0x03EA, 0x03EB), (0x03EC, 0x03ED), (0x03EE, 0x03EF),
    (0x03F4, 0x03F5), (0x03F7, 0x03F8), (0x03F9, 0x03FB), (0x03FD, 0x0430),
    (0x0460, 0x0461), (0x0462, 0x0463), (0x0464, 0x0465), (0x0466, 0x0467),
    (0x0468, 0x0469), (0x046A, 0x046B), (0x046C, 0x046D), (0x046E, 0x046F),
    (0x0470, 0x0471), (0x0472, 0x0473), (0x0474, 0x0475), (0x0476, 0x0477),
    (0x0478, 0x0479), (0x047A, 0x047B), (0x047C, 0x047D), (0x047E, 0x047F),
    (0x0480, 0x0481), (0x048A, 0x048B), (0x048C, 0x048D), (0x048E, 0x048F),
    (0x0490, 0x0491), (0x0492, 0x0493), (0x0494, 0x0495), (0x0496, 0x0497),
    (0x0498, 0x0499), (0x049A, 0x049B), (0x049C, 0x049D), (0x049E, 0x049F),
    (0x04A0, 0x04A1), (0x04A2, 0x04A3), (0x04A4, 0x04A5), (0x04A6, 0x04A7),
    (0x04A8, 0x04A9), (0x04AA, 0x04AB), (0x04AC, 0x04AD), (0x04AE, 0x04AF),
    (0x04B0, 0x04B1), (0x04B2, 0x04B3), (0x04B4, 0x04B5), (0x04B6, 0x04B7),
    (0x04B8, 0x04B9), (0x04BA, 0x04BB), (0x04BC, 0x04BD), (0x04BE, 0x04BF),
    (0x04C0, 0x04C2), (0x04C3, 0x04C4), (0x04C5, 0x04C6), (0x04C7, 0x04C8),
    (0x04C9, 0x04CA), (0x04CB, 0x04CC), (0x04CD, 0x04CE), (0x04D0, 0x04D1),
    (0x04D2, 0x04D3), (0x04D4, 0x04D5), (0x04D6, 0x04D7), (0x04D8, 0x04D9),
    (0x04DA, 0x04DB), (0x04DC, 0x04DD), (0x04DE, 0x04DF), (0x04E0, 0x04E1),
    (0x04E2, 0x04E3), (0x04E4, 0x04E5), (0x04E6, 0x04E7), (0x04E8, 0x04E9),
    (0x04EA, 0x04EB), (0x04EC, 0x04ED), (0x04EE, 0x04EF), (0x04F0, 0x04F1),
    (0x04F2, 0x04F3), (0x04F4, 0x04F5), (0x04F6, 0x04F7), (0x04F8, 0x04F9),
    (0x04FA, 0x04FB), (0x04FC, 0x04FD), (0x04FE, 0x04FF), (0x0500, 0x0501),
    (0x0502, 0x0503), (0x0504, 0x0505), (0x0506, 0x0507), (0x0508, 0x0509),
    (0x050A, 0x050B), (0x050C, 0x050D), (0x050E, 0x050F), (0x0510, 0x0511),
    (0x0512, 0x0513), (0x0514, 0x0515), (0x0516, 0x0517), (0x0518, 0x0519),
    (0x051A, 0x051B), (0x051C, 0x051D), (0x051E, 0x051F), (0x0520, 0x0521),
    (0x0522, 0x0523), (0x0524, 0x0525), (0x0526, 0x0527), (0x0528, 0x0529),
    (0x052A, 0x052B), (0x052C, 0x052D), (0x052E, 0x052F), (0x0531, 0x0557),
    (0x10A0, 0x10C6), (0x10C7, 0x10C8), (0x10CD, 0x10CE), (0x13A0, 0x13F6),
    (0x1E00, 0x1E01), (0x1E02, 0x1E03), (0x1E04, 0x1E05), (0x1E06, 0x1E07),
    (0x1E08, 0x1E09), (0x1E0A, 0x1E0B), (0x1E0C, 0x1E0D), (0x1E0E, 0x1E0F),
    (0x1E10, 0x1E11), (0x1E12, 0x1E13), (0x1E14, 0x1E15), (0x1E16, 0x1E17),
    (0x1E18, 0x1E19), (0x1E1A, 0x1E1B), (0x1E1C, 0x1E1D), (0x1E1E, 0x1E1F),
    (0x1E20, 0x1E21), (0x1E22, 0x1E23), (0x1E24, 0x1E25), (0x1E26, 0x1E27),
    (0x1E28, 0x1E29), (0x1E2A, 0x1E2B), (0x1E2C, 0x1E2D), (0x1E2E, 0x1E2F),
    (0x1E30, 0x1E31), (0x1E32, 0x1E33), (0x1E34, 0x1E35), (0x1E36, 0x1E37),
    (0x1E38, 0x1E39), (0x1E3A, 0x1E3B), (0x1E3C, 0x1E3D), (0x1E3E, 0x1E3F),
    (0x1E40, 0x1E41), (0x1E42, 0x1E43), (0x1E44, 0x1E45), (0x1E46, 0x1E47),
    (0x1E48, 0x1E49), (0x1E4A, 0x1E4B), (0x1E4C, 0x1E4D), (0x1E4E, 0x1E4F),
    (0x1E50, 0x1E51), (0x1E52, 0x1E53), (0x1E54, 0x1E55), (0x1E56, 0x1E57),
    (0x1E58, 0x1E59), (0x1E5A, 0x1E5B), (0x1E5C, 0x1E5D), (0x1E5E, 0x1E5F),
    (0x1E60, 0x1E61), (0x1E62, 0x1E63), (0x1E64, 0x1E65), (0x1E66, 0x1E67),
    (0x1E68, 0x1E69), (0x1E6A, 0x1E6B), (0x1E6C, 0x1E6D), (0x1E6E, 0x1E6F),
    (0x1E70, 0x1E71), (0x1E72, 0x1E73), (0x1E74, 0x1E75), (0x1E76, 0x1E77),
    (0x1E78, 0x1E79), (0x1E7A, 0x1E7B), (0x1E7C, 0x1E7D), (0x1E7E, 0x1E7F),
    (0x1E80, 0x1E81), (0x1E82, 0x1E83), (0x1E84, 0x1E85), (0x1E86, 0x1E87),
    (0x1E88, 0x1E89), (0x1E8A, 0x1E8B), (0x1E8C, 0x1E8D), (0x1E8E, 0x1E8F),
    (0x1E90, 0x1E91), (0x1E92, 0x1E93), (0x1E94, 0x1E95), (0x1E9E, 0x1E9F),
    (0x1EA0, 0x1EA1), (0x1EA2, 0x1EA3), (0x1EA4, 0x1EA5), (0x1EA6, 0x1EA7),
    (0x1EA8, 0x1EA9), (0x1EAA, 0x1EAB), (0x1EAC, 0x1EAD), (0x1EAE, 0x1EAF),
    (0x1EB0, 0x1EB1), (0x1EB2, 0x1EB3), (0x1EB4, 0x1EB5), (0x1EB6, 0x1EB7),
    (0x1EB8, 0x1EB9), (0x1EBA, 0x1EBB), (0x1EBC, 0x1EBD), (0x1EBE, 0x1EBF),
    (0x1EC0, 0x1EC1), (0x1EC2, 0x1EC3), (0x1EC4, 0x1EC5), (0x1EC6, 0x1EC7),
    (0x1EC8, 0x1EC9), (0x1ECA, 0x1ECB), (0x1ECC, 0x1ECD), (0x1ECE, 0x1ECF),
    (0x1ED0, 0x1ED1), (0x1ED2, 0x1ED3), (0x1ED4, 0x1ED5), (0x1ED6, 0x1ED7),
    (0x1ED8, 0x1ED9), (0x1EDA, 0x1EDB), (0x1EDC, 0x1EDD), (0x1EDE, 0x1EDF),
    (0x1EE0, 0x1EE1), (0x1EE2, 0x1EE3), (0x1EE4, 0x1EE5), (0x1EE6, 0x1EE7),
    (0x1EE8, 0x1EE9), (0x1EEA, 0x1EEB), (0x1EEC, 0x1EED), (0x1EEE, 0x1EEF),
    (0x1EF0, 0x1EF1), (0x1EF2, 0x1EF3), (0x1EF4, 0x1EF5), (0x1EF6, 0x1EF7),
    (0x1EF8, 0x1EF9), (0x1EFA, 0x1EFB), (0x1EFC, 0x1EFD), (0x1EFE, 0x1EFF),
    (0x1F08, 0x1F10), (0x1F18, 0x1F1E), (0x1F28, 0x1F30), (0x1F38, 0x1F40),
    (0x1F48, 0x1F4E), (0x1F59, 0x1F5A), (0x1F5B, 0x1F5C), (0x1F5D, 0x1F5E),
    (0x1F5F, 0x1F60), (0x1F68, 0x1F70), (0x1FB8, 0x1FBC), (0x1FC8, 0x1FCC),
    (0x1FD8, 0x1FDC), (0x1FE8, 0x1FED), (0x1FF8, 0x1FFC), (0x2102, 0x2103),
    (0x2107, 0x2108), (0x210B, 0x210E), (0x2110, 0x2113), (0x2115, 0x2116),
    (0x2119, 0x211E), (0x2124, 0x2125), (0x2126, 0x2127), (0x2128, 0x2129),
    (0x212A, 0x212E), (0x2130, 0x2134), (0x213E, 0x2140), (0x2145, 0x2146),
    (0x2183, 0x2184), (0x2C00, 0x2C2F), (0x2C60, 0x2C61), (0x2C62, 0x2C65),
    (0x2C67, 0x2C68), (0x2C69, 0x2C6A), (0x2C6B, 0x2C6C), (0x2C6D, 0x2C71),
    (0x2C72, 0x2C73), (0x2C75, 0x2C76), (0x2C7E, 0x2C81), (0x2C82, 0x2C83),
    (0x2C84, 0x2C85), (0x2C86, 0x2C87), (0x2C88, 0x2C89), (0x2C8A, 0x2C8B),
    (0x2C8C, 0x2C8D), (0x2C8E, 0x2C8F), (0x2C90, 0x2C91), (0x2C92, 0x2C93),
    (0x2C94, 0x2C95), (0x2C96, 0x2C97), (0x2C98, 0x2C99), (0x2C9A, 0x2C9B),
    (0x2C9C, 0x2C9D), (0x2C9E, 0x2C9F), (0x2CA0, 0x2CA1), (0x2CA2, 0x2CA3),
    (0x2CA4, 0x2CA5), (0x2CA6, 0x2CA7), (0x2CA8, 0x2CA9), (0x2CAA, 0x2CAB),
    (0x2CAC, 0x2CAD), (0x2CAE, 0x2CAF), (0x2CB0, 0x2CB1), (0x2CB2, 0x2CB3),
    (0x2CB4, 0x2CB5), (0x2CB6, 0x2CB7), (0x2CB8, 0x2CB9), (0x2CBA, 0x2CBB),
    (0x2CBC, 0x2CBD), (0x2CBE, 0x2CBF), (0x2CC0, 0x2CC1), (0x2CC2, 0x2CC3),
    (0x2CC4, 0x2CC5), (0x2CC6, 0x2CC7), (0x2CC8, 0x2CC9), (0x2CCA, 0x2CCB),
    (0x2CCC, 0x2CCD), (0x2CCE, 0x2CCF), (0x2CD0, 0x2CD1), (0x2CD2, 0x2CD3),
    (0x2CD4, 0x2CD5), (0x2CD6, 0x2CD7), (0x2CD8, 0x2CD9), (0x2CDA, 0x2CDB),
    (0x2CDC, 0x2CDD), (0x2CDE, 0x2CDF), (0x2CE0, 0x2CE1), (0x2CE2, 0x2CE3),
    (0x2CEB, 0x2CEC), (0x2CED, 0x2CEE), (0x2CF2, 0x2CF3), (0xA640, 0xA641),
    (0xA642, 0xA643), (0xA644, 0xA645), (0xA646, 0xA647), (0xA648, 0xA649),
    (0xA64A, 0xA64B), (0xA64C, 0xA64D), (0xA64E, 0xA64F), (0xA650, 0xA651),
    (0xA652, 0xA653), (0xA654, 0xA655), (0xA656, 0xA657), (0xA658, 0xA659),
    (0xA65A, 0xA65B), (0xA65C, 0xA65D), (0xA65E, 0xA65F), (0xA660, 0xA661),
    (0xA662, 0xA663), (0xA664, 0xA665), (0xA666, 0xA667), (0xA668, 0xA669),
    (0xA66A, 0xA66B), (0xA66C, 0xA66D), (0xA680, 0xA681), (0xA682, 0xA683),
    (0xA684, 0xA685), (0xA686, 0xA687), (0xA688, 0xA689), (0xA68A, 0xA68B),
    (0xA68C, 0xA68D), (0xA68E, 0xA68F), (0xA690, 0xA691), (0xA692, 0xA693),
    (0xA694, 0xA695), (0xA696, 0xA697), (0xA698, 0xA699), (0xA69A, 0xA69B),
    (0xA722, 0xA723), (0xA724, 0xA725), (0xA726, 0xA727), (0xA728, 0xA729),
    (0xA72A, 0xA72B), (0xA72C, 0xA72D), (0xA72E, 0xA72F), (0xA732, 0xA733),
    (0xA734, 0xA735), (0xA736, 0xA737), (0xA738, 0xA739), (0xA73A, 0xA73B),
    (0xA73C, 0xA73D), (0xA73E, 0xA73F), (0xA740, 0xA741), (0xA742, 0xA743),
    (0xA744, 0xA745), (0xA746, 0xA747), (0xA748, 0xA749), (0xA74A, 0xA74B),
    (0xA74C, 0xA74D), (0xA74E, 0xA74F), (0xA750, 0xA751), (0xA752, 0xA753),
    (0xA754, 0xA755), (0xA756, 0xA757), (0xA758, 0xA759), (0xA75A, 0xA75B),
    (0xA75C, 0xA75D), (0xA75E, 0xA75F), (0xA760, 0xA761), (0xA762, 0xA763),
    (0xA764, 0xA765), (0xA766, 0xA767), (0xA768, 0xA769), (0xA76A, 0xA76B),
    (0xA76C, 0xA76D), (0xA76E, 0xA76F), (0xA779, 0xA77A), (0xA77B, 0xA77C),
    (0xA77D, 0xA77F), (0xA780, 0xA781), (0xA782, 0xA783), (0xA784, 0xA785),
    (0xA786, 0xA787), (0xA78B, 0xA78C), (0xA78D, 0xA78E), (0xA790, 0xA791),
    (0xA792, 0xA793), (0xA796, 0xA797), (0xA798, 0xA799), (0xA79A, 0xA79B),
    (0xA79C, 0xA79D), (0xA79E, 0xA79F), (0xA7A0, 0xA7A1), (0xA7A2, 0xA7A3),
    (0xA7A4, 0xA7A5), (0xA7A6, 0xA7A7), (0xA7A8, 0xA7A9), (0xA7AA, 0xA7AF),
    (0xA7B0, 0xA7B5), (0xA7B6, 0xA7B7), (0xFF21, 0xFF3B), (0x10400, 0x10428),
    (0x104B0, 0x104D4), (0x10C80, 0x10CB3), (0x118A0, 0x118C0), (0x1D400, 0x1D41A),
    (0x1D434, 0x1D44E), (0x1D468, 0x1D482), (0x1D49C, 0x1D49D), (0x1D49E, 0x1D4A0),
    (0x1D4A2, 0x1D4A3), (0x1D4A5, 0x1D4A7), (0x1D4A9, 0x1D4AD), (0x1D4AE, 0x1D4B6),
    (0x1D4D0, 0x1D4EA), (0x1D504, 0x1D506), (0x1D507, 0x1D50B), (0x1D50D, 0x1D515),
    (0x1D516, 0x1D51D), (0x1D538, 0x1D53A), (0x1D53B, 0x1D53F), (0x1D540, 0x1D545),
    (0x1D546, 0x1D547), (0x1D54A, 0x1D551), (0x1D56C, 0x1D586), (0x1D5A0, 0x1D5BA),
    (0x1D5D4, 0x1D5EE), (0x1D608, 0x1D622), (0x1D63C, 0x1D656), (0x1D670, 0x1D68A),
    (0x1D6A8, 0x1D6C1), (0x1D6E2, 0x1D6FB), (0x1D71C, 0x1D735), (0x1D756, 0x1D76F),
    (0x1D790, 0x1D7A9), (0x1D7CA, 0x1D7CB), (0x1E900, 0x1E922),
  ),

  'Mc': (
    (0x0903, 0x0904), (0x093B, 0x093C), (0x093E, 0x0941), (0x0949, 0x094D),
    (0x094E, 0x0950), (0x0982, 0x0984), (0x09BE, 0x09C1), (0x09C7, 0x09C9),
    (0x09CB, 0x09CD), (0x09D7, 0x09D8), (0x0A03, 0x0A04), (0x0A3E, 0x0A41),
    (0x0A83, 0x0A84), (0x0ABE, 0x0AC1), (0x0AC9, 0x0ACA), (0x0ACB, 0x0ACD),
    (0x0B02, 0x0B04), (0x0B3E, 0x0B3F), (0x0B40, 0x0B41), (0x0B47, 0x0B49),
    (0x0B4B, 0x0B4D), (0x0B57, 0x0B58), (0x0BBE, 0x0BC0), (0x0BC1, 0x0BC3),
    (0x0BC6, 0x0BC9), (0x0BCA, 0x0BCD), (0x0BD7, 0x0BD8), (0x0C01, 0x0C04),
    (0x0C41, 0x0C45), (0x0C82, 0x0C84), (0x0CBE, 0x0CBF), (0x0CC0, 0x0CC5),
    (0x0CC7, 0x0CC9), (0x0CCA, 0x0CCC), (0x0CD5, 0x0CD7), (0x0D02, 0x0D04),
    (0x0D3E, 0x0D41), (0x0D46, 0x0D49), (0x0D4A, 0x0D4D), (0x0D57, 0x0D58),
    (0x0D82, 0x0D84), (0x0DCF, 0x0DD2), (0x0DD8, 0x0DE0), (0x0DF2, 0x0DF4),
    (0x0F3E, 0x0F40), (0x0F7F, 0x0F80), (0x102B, 0x102D), (0x1031, 0x1032),
    (0x1038, 0x1039), (0x103B, 0x103D), (0x1056, 0x1058), (0x1062, 0x1065),
    (0x1067, 0x106E), (0x1083, 0x1085), (0x1087, 0x108D), (0x108F, 0x1090),
    (0x109A, 0x109D), (0x17B6, 0x17B7), (0x17BE, 0x17C6), (0x17C7, 0x17C9),
    (0x1923, 0x1927), (0x1929, 0x192C), (0x1930, 0x1932), (0x1933, 0x1939),
    (0x1A19, 0x1A1B), (0x1A55, 0x1A56), (0x1A57, 0x1A58), (0x1A61, 0x1A62),
    (0x1A63, 0x1A65), (0x1A6D, 0x1A73), (0x1B04, 0x1B05), (0x1B35, 0x1B36),
    (0x1B3B, 0x1B3C), (0x1B3D, 0x1B42), (0x1B43, 0x1B45), (0x1B82, 0x1B83),
    (0x1BA1, 0x1BA2), (0x1BA6, 0x1BA8), (0x1BAA, 0x1BAB), (0x1BE7, 0x1BE8),
    (0x1BEA, 0x1BED), (0x1BEE, 0x1BEF), (0x1BF2, 0x1BF4), (0x1C24, 0x1C2C),
    (0x1C34, 0x1C36), (0x1CE1, 0x1CE2), (0x1CF2, 0x1CF4), (0x302E, 0x3030),
    (0xA823, 0xA825), (0xA827, 0xA828), (0xA880, 0xA882), (0xA8B4, 0xA8C4),
    (0xA952, 0xA954), (0xA983, 0xA984), (0xA9B4, 0xA9B6), (0xA9BA, 0xA9BC),
    (0xA9BD, 0xA9C1), (0xAA2F, 0xAA31), (0xAA33, 0xAA35), (0xAA4D, 0xAA4E),
    (0xAA7B, 0xAA7C), (0xAA7D, 0xAA7E), (0xAAEB, 0xAAEC), (0xAAEE, 0xAAF0),
    (0xAAF5, 0xAAF6), (0xABE3, 0xABE5), (0xABE6, 0xABE8), (0xABE9, 0xABEB),
    (0xABEC, 0xABED), (0x11000, 0x11001), (0x11002, 0x11003), (0x11082, 0x11083),
    (0x110B0, 0x110B3), (0x110B7, 0x110B9), (0x1112C, 0x1112D), (0x11182, 0x11183),
    (0x111B3, 0x111B6), (0x111BF, 0x111C1), (0x1122C, 0x1122F), (0x11232, 0x11234),
    (0x11235, 0x11236), (0x112E0, 0x112E3), (0x11302, 0x11304), (0x1133E, 0x11340),
    (0x11341, 0x11345), (0x11347, 0x11349), (0x1134B, 0x1134E), (0x11357, 0x11358),
    (0x11362, 0x11364), (0x11435, 0x11438), (0x11440, 0x11442), (0x11445, 0x11446),
    (0x114B0, 0x114B3), (0x114B9, 0x114BA), (0x114BB, 0x114BF), (0x114C1, 0x114C2),
    (0x115AF, 0x115B2), (0x115B8, 0x115BC), (0x115BE, 0x115BF), (0x11630, 0x11633),
    (0x1163B, 0x1163D), (0x1163E, 0x1163F), (0x116AC, 0x116AD), (0x116AE, 0x116B0),
    (0x116B6, 0x116B7), (0x11720, 0x11722), (0x11726, 0x11727), (0x11C2F, 0x11C30),
    (0x11C3E, 0x11C3F), (0x11CA9, 0x11CAA), (0x11CB1, 0x11CB2), (0x11CB4, 0x11CB5),
    (0x16F51, 0x16F7F), (0x1D165, 0x1D167), (0x1D16D, 0x1D173),
  ),

  'Me': (
    (0x0488, 0x048A), (0x1ABE, 0x1ABF), (0x20DD, 0x20E1), (0x20E2, 0x20E5),
    (0xA670, 0xA673),
  ),

  'Mn': (
    (0x0300, 0x0370), (0x0483, 0x0488), (0x0591, 0x05BE), (0x05BF, 0x05C0),
    (0x05C1, 0x05C3), (0x05C4, 0x05C6), (0x05C7, 0x05C8), (0x0610, 0x061B),
    (0x064B, 0x0660), (0x0670, 0x0671), (0x06D6, 0x06DD), (0x06DF, 0x06E5),
    (0x06E7, 0x06E9), (0x06EA, 0x06EE), (0x0711, 0x0712), (0x0730, 0x074B),
    (0x07A6, 0x07B1), (0x07EB, 0x07F4), (0x0816, 0x081A), (0x081B, 0x0824),
    (0x0825, 0x0828), (0x0829, 0x082E), (0x0859, 0x085C), (0x08D4, 0x08E2),
    (0x08E3, 0x0903), (0x093A, 0x093B), (0x093C, 0x093D), (0x0941, 0x0949),
    (0x094D, 0x094E), (0x0951, 0x0958), (0x0962, 0x0964), (0x0981, 0x0982),
    (0x09BC, 0x09BD), (0x09C1, 0x09C5), (0x09CD, 0x09CE), (0x09E2, 0x09E4),
    (0x0A01, 0x0A03), (0x0A3C, 0x0A3D), (0x0A41, 0x0A43), (0x0A47, 0x0A49),
    (0x0A4B, 0x0A4E), (0x0A51, 0x0A52), (0x0A70, 0x0A72), (0x0A75, 0x0A76),
    (0x0A81, 0x0A83), (0x0ABC, 0x0ABD), (0x0AC1, 0x0AC6), (0x0AC7, 0x0AC9),
    (0x0ACD, 0x0ACE), (0x0AE2, 0x0AE4), (0x0B01, 0x0B02), (0x0B3C, 0x0B3D),
    (0x0B3F, 0x0B40), (0x0B41, 0x0B45), (0x0B4D, 0x0B4E), (0x0B56, 0x0B57),
    (0x0B62, 0x0B64), (0x0B82, 0x0B83), (0x0BC0, 0x0BC1), (0x0BCD, 0x0BCE),
    (0x0C00, 0x0C01), (0x0C3E, 0x0C41), (0x0C46, 0x0C49), (0x0C4A, 0x0C4E),
    (0x0C55, 0x0C57), (0x0C62, 0x0C64), (0x0C81, 0x0C82), (0x0CBC, 0x0CBD),
    (0x0CBF, 0x0CC0), (0x0CC6, 0x0CC7), (0x0CCC, 0x0CCE), (0x0CE2, 0x0CE4),
    (0x0D01, 0x0D02), (0x0D41, 0x0D45), (0x0D4D, 0x0D4E), (0x0D62, 0x0D64),
    (0x0DCA, 0x0DCB), (0x0DD2, 0x0DD5), (0x0DD6, 0x0DD7), (0x0E31, 0x0E32),
    (0x0E34, 0x0E3B), (0x0E47, 0x0E4F), (0x0EB1, 0x0EB2), (0x0EB4, 0x0EBA),
    (0x0EBB, 0x0EBD), (0x0EC8, 0x0ECE), (0x0F18, 0x0F1A), (0x0F35, 0x0F36),
    (0x0F37, 0x0F38), (0x0F39, 0x0F3A), (0x0F71, 0x0F7F), (0x0F80, 0x0F85),
    (0x0F86, 0x0F88), (0x0F8D, 0x0F98), (0x0F99, 0x0FBD), (0x0FC6, 0x0FC7),
    (0x102D, 0x1031), (0x1032, 0x1038), (0x1039, 0x103B), (0x103D, 0x103F),
    (0x1058, 0x105A), (0x105E, 0x1061), (0x1071, 0x1075), (0x1082, 0x1083),
    (0x1085, 0x1087), (0x108D, 0x108E), (0x109D, 0x109E), (0x135D, 0x1360),
    (0x1712, 0x1715), (0x1732, 0x1735), (0x1752, 0x1754), (0x1772, 0x1774),
    (0x17B4, 0x17B6), (0x17B7, 0x17BE), (0x17C6, 0x17C7), (0x17C9, 0x17D4),
    (0x17DD, 0x17DE), (0x180B, 0x180E), (0x1885, 0x1887), (0x18A9, 0x18AA),
    (0x1920, 0x1923), (0x1927, 0x1929), (0x1932, 0x1933), (0x1939, 0x193C),
    (0x1A17, 0x1A19), (0x1A1B, 0x1A1C), (0x1A56, 0x1A57), (0x1A58, 0x1A5F),
    (0x1A60, 0x1A61), (0x1A62, 0x1A63), (0x1A65, 0x1A6D), (0x1A73, 0x1A7D),
    (0x1A7F, 0x1A80), (0x1AB0, 0x1ABE), (0x1B00, 0x1B04), (0x1B34, 0x1B35),
    (0x1B36, 0x1B3B), (0x1B3C, 0x1B3D), (0x1B42, 0x1B43), (0x1B6B, 0x1B74),
    (0x1B80, 0x1B82), (0x1BA2, 0x1BA6), (0x1BA8, 0x1BAA), (0x1BAB, 0x1BAE),
    (0x1BE6, 0x1BE7), (0x1BE8, 0x1BEA), (0x1BED, 0x1BEE), (0x1BEF, 0x1BF2),
    (0x1C2C, 0x1C34), (0x1C36, 0x1C38), (0x1CD0, 0x1CD3), (0x1CD4, 0x1CE1),
    (0x1CE2, 0x1CE9), (0x1CED, 0x1CEE), (0x1CF4, 0x1CF5), (0x1CF8, 0x1CFA),
    (0x1DC0, 0x1DF6), (0x1DFB, 0x1E00), (0x20D0, 0x20DD), (0x20E1, 0x20E2),
    (0x20E5, 0x20F1), (0x2CEF, 0x2CF2), (0x2D7F, 0x2D80), (0x2DE0, 0x2E00),
    (0x302A, 0x302E), (0x3099, 0x309B), (0xA66F, 0xA670), (0xA674, 0xA67E),
    (0xA69E, 0xA6A0), (0xA6F0, 0xA6F2), (0xA802, 0xA803), (0xA806, 0xA807),
    (0xA80B, 0xA80C), (0xA825, 0xA827), (0xA8C4, 0xA8C6), (0xA8E0, 0xA8F2),
    (0xA926, 0xA92E), (0xA947, 0xA952), (0xA980, 0xA983), (0xA9B3, 0xA9B4),
    (0xA9B6, 0xA9BA), (0xA9BC, 0xA9BD), (0xA9E5, 0xA9E6), (0xAA29, 0xAA2F),
    (0xAA31, 0xAA33), (0xAA35, 0xAA37), (0xAA43, 0xAA44), (0xAA4C, 0xAA4D),
    (0xAA7C, 0xAA7D), (0xAAB0, 0xAAB1), (0xAAB2, 0xAAB5), (0xAAB7, 0xAAB9),
    (0xAABE, 0xAAC0), (0xAAC1, 0xAAC2), (0xAAEC, 0xAAEE), (0xAAF6, 0xAAF7),
    (0xABE5, 0xABE6), (0xABE8, 0xABE9), (0xABED, 0xABEE), (0xFB1E, 0xFB1F),
    (0xFE00, 0xFE10), (0xFE20, 0xFE30), (0x101FD, 0x101FE), (0x102E0, 0x102E1),
    (0x10376, 0x1037B), (0x10A01, 0x10A04), (0x10A05, 0x10A07), (0x10A0C, 0x10A10),
    (0x10A38, 0x10A3B), (0x10A3F, 0x10A40), (0x10AE5, 0x10AE7), (0x11001, 0x11002),
    (0x11038, 0x11047), (0x1107F, 0x11082), (0x110B3, 0x110B7), (0x110B9, 0x110BB),
    (0x11100, 0x11103), (0x11127, 0x1112C), (0x1112D, 0x11135), (0x11173, 0x11174),
    (0x11180, 0x11182), (0x111B6, 0x111BF), (0x111CA, 0x111CD), (0x1122F, 0x11232),
    (0x11234, 0x11235), (0x11236, 0x11238), (0x1123E, 0x1123F), (0x112DF, 0x112E0),
    (0x112E3, 0x112EB), (0x11300, 0x11302), (0x1133C, 0x1133D), (0x11340, 0x11341),
    (0x11366, 0x1136D), (0x11370, 0x11375), (0x11438, 0x11440), (0x11442, 0x11445),
    (0x11446, 0x11447), (0x114B3, 0x114B9), (0x114BA, 0x114BB), (0x114BF, 0x114C1),
    (0x114C2, 0x114C4), (0x115B2, 0x115B6), (0x115BC, 0x115BE), (0x115BF, 0x115C1),
    (0x115DC, 0x115DE), (0x11633, 0x1163B), (0x1163D, 0x1163E), (0x1163F, 0x11641),
    (0x116AB, 0x116AC), (0x116AD, 0x116AE), (0x116B0, 0x116B6), (0x116B7, 0x116B8),
    (0x1171D, 0x11720), (0x11722, 0x11726), (0x11727, 0x1172C), (0x11C30, 0x11C37),
    (0x11C38, 0x11C3E), (0x11C3F, 0x11C40), (0x11C92, 0x11CA8), (0x11CAA, 0x11CB1),
    (0x11CB2, 0x11CB4), (0x11CB5, 0x11CB7), (0x16AF0, 0x16AF5), (0x16B30, 0x16B37),
    (0x16F8F, 0x16F93), (0x1BC9D, 0x1BC9F), (0x1D167, 0x1D16A), (0x1D17B, 0x1D183),
    (0x1D185, 0x1D18C), (0x1D1AA, 0x1D1AE), (0x1D242, 0x1D245), (0x1DA00, 0x1DA37),
    (0x1DA3B, 0x1DA6D), (0x1DA75, 0x1DA76), (0x1DA84, 0x1DA85), (0x1DA9B, 0x1DAA0),
    (0x1DAA1, 0x1DAB0), (0x1E000, 0x1E007), (0x1E008, 0x1E019), (0x1E01B, 0x1E022),
    (0x1E023, 0x1E025), (0x1E026, 0x1E02B), (0x1E8D0, 0x1E8D7), (0x1E944, 0x1E94B),
    (0xE0100, 0xE01F0),
  ),

  'Nd': (
    (0x0030, 0x003A), (0x0660, 0x066A), (0x06F0, 0x06FA), (0x07C0, 0x07CA),
    (0x0966, 0x0970), (0x09E6, 0x09F0), (0x0A66, 0x0A70), (0x0AE6, 0x0AF0),
    (0x0B66, 0x0B70), (0x0BE6, 0x0BF0), (0x0C66, 0x0C70), (0x0CE6, 0x0CF0),
    (0x0D66, 0x0D70), (0x0DE6, 0x0DF0), (0x0E50, 0x0E5A), (0x0ED0, 0x0EDA),
    (0x0F20, 0x0F2A), (0x1040, 0x104A), (0x1090, 0x109A), (0x17E0, 0x17EA),
    (0x1810, 0x181A), (0x1946, 0x1950), (0x19D0, 0x19DA), (0x1A80, 0x1A8A),
    (0x1A90, 0x1A9A), (0x1B50, 0x1B5A), (0x1BB0, 0x1BBA), (0x1C40, 0x1C4A),
    (0x1C50, 0x1C5A), (0xA620, 0xA62A), (0xA8D0, 0xA8DA), (0xA900, 0xA90A),
    (0xA9D0, 0xA9DA), (0xA9F0, 0xA9FA), (0xAA50, 0xAA5A), (0xABF0, 0xABFA),
    (0xFF10, 0xFF1A), (0x104A0, 0x104AA), (0x11066, 0x11070), (0x110F0, 0x110FA),
    (0x11136, 0x11140), (0x111D0, 0x111DA), (0x112F0, 0x112FA), (0x11450, 0x1145A),
    (0x114D0, 0x114DA), (0x11650, 0x1165A), (0x116C0, 0x116CA), (0x11730, 0x1173A),
    (0x118E0, 0x118EA), (0x11C50, 0x11C5A), (0x16A60, 0x16A6A), (0x16B50, 0x16B5A),
    (0x1D7CE, 0x1D800), (0x1E950, 0x1E95A),
  ),

  'Nl': (
    (0x16EE, 0x16F1), (0x2160, 0x2183), (0x2185, 0x2189), (0x3007, 0x3008),
    (0x3021, 0x302A), (0x3038, 0x303B), (0xA6E6, 0xA6F0), (0x10140, 0x10175),
    (0x10341, 0x10342), (0x1034A, 0x1034B), (0x103D1, 0x103D6), (0x12400, 0x1246F),
  ),

  'No': (
    (0x00B2, 0x00B4), (0x00B9, 0x00BA), (0x00BC, 0x00BF), (0x09F4, 0x09FA),
    (0x0B72, 0x0B78), (0x0BF0, 0x0BF3), (0x0C78, 0x0C7F), (0x0D58, 0x0D5F),
    (0x0D70, 0x0D79), (0x0F2A, 0x0F34), (0x1369, 0x137D), (0x17F0, 0x17FA),
    (0x19DA, 0x19DB), (0x2070, 0x2071), (0x2074, 0x207A), (0x2080, 0x208A),
    (0x2150, 0x2160), (0x2189, 0x218A), (0x2460, 0x249C), (0x24EA, 0x2500),
    (0x2776, 0x2794), (0x2CFD, 0x2CFE), (0x3192, 0x3196), (0x3220, 0x322A),
    (0x3248, 0x3250), (0x3251, 0x3260), (0x3280, 0x328A), (0x32B1, 0x32C0),
    (0xA830, 0xA836), (0x10107, 0x10134), (0x10175, 0x10179), (0x1018A, 0x1018C),
    (0x102E1, 0x102FC), (0x10320, 0x10324), (0x10858, 0x10860), (0x10879, 0x10880),
    (0x108A7, 0x108B0), (0x108FB, 0x10900), (0x10916, 0x1091C), (0x109BC, 0x109BE),
    (0x109C0, 0x109D0), (0x109D2, 0x10A00), (0x10A40, 0x10A48), (0x10A7D, 0x10A7F),
    (0x10A9D, 0x10AA0), (0x10AEB, 0x10AF0), (0x10B58, 0x10B60), (0x10B78, 0x10B80),
    (0x10BA9, 0x10BB0), (0x10CFA, 0x10D00), (0x10E60, 0x10E7F), (0x11052, 0x11066),
    (0x111E1, 0x111F5), (0x1173A, 0x1173C), (0x118EA, 0x118F3), (0x11C5A, 0x11C6D),
    (0x16B5B, 0x16B62), (0x1D360, 0x1D372), (0x1E8C7, 0x1E8D0), (0x1F100, 0x1F10D),
  ),

  'Pc': (
    (0x005F, 0x0060), (0x203F, 0x2041), (0x2054, 0x2055), (0xFE33, 0xFE35),
    (0xFE4D, 0xFE50), (0xFF3F, 0xFF40),
  ),

  'Pd': (
    (0x002D, 0x002E), (0x058A, 0x058B), (0x05BE, 0x05BF), (0x1400, 0x1401),
    (0x1806, 0x1807), (0x2010, 0x2016), (0x2E17, 0x2E18), (0x2E1A, 0x2E1B),
    (0x2E3A, 0x2E3C), (0x2E40, 0x2E41), (0x301C, 0x301D), (0x3030, 0x3031),
    (0x30A0, 0x30A1), (0xFE31, 0xFE33), (0xFE58, 0xFE59), (0xFE63, 0xFE64),
    (0xFF0D, 0xFF0E),
  ),

  'Pe': (
    (0x0029, 0x002A), (0x005D, 0x005E), (0x007D, 0x007E), (0x0F3B, 0x0F3C),
    (0x0F3D, 0x0F3E), (0x169C, 0x169D), (0x2046, 0x2047), (0x207E, 0x207F),
    (0x208E, 0x208F), (0x2309, 0x230A), (0x230B, 0x230C), (0x232A, 0x232B),
    (0x2769, 0x276A), (0x276B, 0x276C), (0x276D, 0x276E), (0x276F, 0x2770),
    (0x2771, 0x2772), (0x2773, 0x2774), (0x2775, 0x2776), (0x27C6, 0x27C7),
    (0x27E7, 0x27E8), (0x27E9, 0x27EA), (0x27EB, 0x27EC), (0x27ED, 0x27EE),
    (0x27EF, 0x27F0), (0x2984, 0x2985), (0x2986, 0x2987), (0x2988, 0x2989),
    (0x298A, 0x298B), (0x298C, 0x298D), (0x298E, 0x298F), (0x2990, 0x2991),
    (0x2992, 0x2993), (0x2994, 0x2995), (0x2996, 0x2997), (0x2998, 0x2999),
    (0x29D9, 0x29DA), (0x29DB, 0x29DC), (0x29FD, 0x29FE), (0x2E23, 0x2E24),
    (0x2E25, 0x2E26), (0x2E27, 0x2E28), (0x2E29, 0x2E2A), (0x3009, 0x300A),
    (0x300B, 0x300C), (0x300D, 0x300E), (0x300F, 0x3010), (0x3011, 0x3012),
    (0x3015, 0x3016), (0x3017, 0x3018), (0x3019, 0x301A), (0x301B, 0x301C),
    (0x301E, 0x3020), (0xFD3E, 0xFD3F), (0xFE18, 0xFE19), (0xFE36, 0xFE37),
    (0xFE38, 0xFE39), (0xFE3A, 0xFE3B), (0xFE3C, 0xFE3D), (0xFE3E, 0xFE3F),
    (0xFE40, 0xFE41), (0xFE42, 0xFE43), (0xFE44, 0xFE45), (0xFE48, 0xFE49),
    (0xFE5A, 0xFE5B), (0xFE5C, 0xFE5D), (0xFE5E, 0xFE5F), (0xFF09, 0xFF0A),
    (0xFF3D, 0xFF3E), (0xFF5D, 0xFF5E), (0xFF60, 0xFF61), (0xFF63, 0xFF64),
  ),

  'Pf': (
    (0x00BB, 0x00BC), (0x2019, 0x201A), (0x201D, 0x201E), (0x203A, 0x203B),
    (0x2E03, 0x2E04), (0x2E05, 0x2E06), (0x2E0A, 0x2E0B), (0x2E0D, 0x2E0E),
    (0x2E1D, 0x2E1E), (0x2E21, 0x2E22),
  ),

  'Pi': (
    (0x00AB, 0x00AC), (0x2018, 0x2019), (0x201B, 0x201D), (0x201F, 0x2020),
    (0x2039, 0x203A), (0x2E02, 0x2E03), (0x2E04, 0x2E05), (0x2E09, 0x2E0A),
    (0x2E0C, 0x2E0D), (0x2E1C, 0x2E1D), (0x2E20, 0x2E21),
  ),

  'Po': (
    (0x0021, 0x0024), (0x0025, 0x0028), (0x002A, 0x002B), (0x002C, 0x002D),
    (0x002E, 0x0030), (0x003A, 0x003C), (0x003F, 0x0041), (0x005C, 0x005D),
    (0x00A1, 0x00A2), (0x00A7, 0x00A8), (0x00B6, 0x00B8), (0x00BF, 0x00C0),
    (0x037E, 0x037F), (0x0387, 0x0388), (0x055A, 0x0560), (0x0589, 0x058A),
    (0x05C0, 0x05C1), (0x05C3, 0x05C4), (0x05C6, 0x05C7), (0x05F3, 0x05F5),
    (0x0609, 0x060B), (0x060C, 0x060E), (0x061B, 0x061C), (0x061E, 0x0620),
    (0x066A, 0x066E), (0x06D4, 0x06D5), (0x0700, 0x070E), (0x07F7, 0x07FA),
    (0x0830, 0x083F), (0x085E, 0x085F), (0x0964, 0x0966), (0x0970, 0x0971),
    (0x0AF0, 0x0AF1), (0x0DF4, 0x0DF5), (0x0E4F, 0x0E50), (0x0E5A, 0x0E5C),
    (0x0F04, 0x0F13), (0x0F14, 0x0F15), (0x0F85, 0x0F86), (0x0FD0, 0x0FD5),
    (0x0FD9, 0x0FDB), (0x104A, 0x1050), (0x10FB, 0x10FC), (0x1360, 0x1369),
    (0x166D, 0x166F), (0x16EB, 0x16EE), (0x1735, 0x1737), (0x17D4, 0x17D7),
    (0x17D8, 0x17DB), (0x1800, 0x1806), (0x1807, 0x180B), (0x1944, 0x1946),
    (0x1A1E, 0x1A20), (0x1AA0, 0x1AA7), (0x1AA8, 0x1AAE), (0x1B5A, 0x1B61),
    (0x1BFC, 0x1C00), (0x1C3B, 0x1C40), (0x1C7E, 0x1C80), (0x1CC0, 0x1CC8),
    (0x1CD3, 0x1CD4), (0x2016, 0x2018), (0x2020, 0x2028), (0x2030, 0x2039),
    (0x203B, 0x203F), (0x2041, 0x2044), (0x2047, 0x2052), (0x2053, 0x2054),
    (0x2055, 0x205F), (0x2CF9, 0x2CFD), (0x2CFE, 0x2D00), (0x2D70, 0x2D71),
    (0x2E00, 0x2E02), (0x2E06, 0x2E09), (0x2E0B, 0x2E0C), (0x2E0E, 0x2E17),
    (0x2E18, 0x2E1A), (0x2E1B, 0x2E1C), (0x2E1E, 0x2E20), (0x2E2A, 0x2E2F),
    (0x2E30, 0x2E3A), (0x2E3C, 0x2E40), (0x2E41, 0x2E42), (0x2E43, 0x2E45),
    (0x3001, 0x3004), (0x303D, 0x303E), (0x30FB, 0x30FC), (0xA4FE, 0xA500),
    (0xA60D, 0xA610), (0xA673, 0xA674), (0xA67E, 0xA67F), (0xA6F2, 0xA6F8),
    (0xA874, 0xA878), (0xA8CE, 0xA8D0), (0xA8F8, 0xA8FB), (0xA8FC, 0xA8FD),
    (0xA92E, 0xA930), (0xA95F, 0xA960), (0xA9C1, 0xA9CE), (0xA9DE, 0xA9E0),
    (0xAA5C, 0xAA60), (0xAADE, 0xAAE0), (0xAAF0, 0xAAF2), (0xABEB, 0xABEC),
    (0xFE10, 0xFE17), (0xFE19, 0xFE1A), (0xFE30, 0xFE31), (0xFE45, 0xFE47),
    (0xFE49, 0xFE4D), (0xFE50, 0xFE53), (0xFE54, 0xFE58), (0xFE5F, 0xFE62),
    (0xFE68, 0xFE69), (0xFE6A, 0xFE6C), (0xFF01, 0xFF04), (0xFF05, 0xFF08),
    (0xFF0A, 0xFF0B), (0xFF0C, 0xFF0D), (0xFF0E, 0xFF10), (0xFF1A, 0xFF1C),
    (0xFF1F, 0xFF21), (0xFF3C, 0xFF3D), (0xFF61, 0xFF62), (0xFF64, 0xFF66),
    (0x10100, 0x10103), (0x1039F, 0x103A0), (0x103D0, 0x103D1), (0x1056F, 0x10570),
    (0x10857, 0x10858), (0x1091F, 0x10920), (0x1093F, 0x10940), (0x10A50, 0x10A59),
    (0x10A7F, 0x10A80), (0x10AF0, 0x10AF7), (0x10B39, 0x10B40), (0x10B99, 0x10B9D),
    (0x11047, 0x1104E), (0x110BB, 0x110BD), (0x110BE, 0x110C2), (0x11140, 0x11144),
    (0x11174, 0x11176), (0x111C5, 0x111CA), (0x111CD, 0x111CE), (0x111DB, 0x111DC),
    (0x111DD, 0x111E0), (0x11238, 0x1123E), (0x112A9, 0x112AA), (0x1144B, 0x11450),
    (0x1145B, 0x1145C), (0x1145D, 0x1145E), (0x114C6, 0x114C7), (0x115C1, 0x115D8),
    (0x11641, 0x11644), (0x11660, 0x1166D), (0x1173C, 0x1173F), (0x11C41, 0x11C46),
    (0x11C70, 0x11C72), (0x12470, 0x12475), (0x16A6E, 0x16A70), (0x16AF5, 0x16AF6),
    (0x16B37, 0x16B3C), (0x16B44, 0x16B45), (0x1BC9F, 0x1BCA0), (0x1DA87, 0x1DA8C),
    (0x1E95E, 0x1E960),
  ),

  'Ps': (
    (0x0028, 0x0029), (0x005B, 0x005C), (0x007B, 0x007C), (0x0F3A, 0x0F3B),
    (0x0F3C, 0x0F3D), (0x169B, 0x169C), (0x201A, 0x201B), (0x201E, 0x201F),
    (0x2045, 0x2046), (0x207D, 0x207E), (0x208D, 0x208E), (0x2308, 0x2309),
    (0x230A, 0x230B), (0x2329, 0x232A), (0x2768, 0x2769), (0x276A, 0x276B),
    (0x276C, 0x276D), (0x276E, 0x276F), (0x2770, 0x2771), (0x2772, 0x2773),
    (0x2774, 0x2775), (0x27C5, 0x27C6), (0x27E6, 0x27E7), (0x27E8, 0x27E9),
    (0x27EA, 0x27EB), (0x27EC, 0x27ED), (0x27EE, 0x27EF), (0x2983, 0x2984),
    (0x2985, 0x2986), (0x2987, 0x2988), (0x2989, 0x298A), (0x298B, 0x298C),
    (0x298D, 0x298E), (0x298F, 0x2990), (0x2991, 0x2992), (0x2993, 0x2994),
    (0x2995, 0x2996), (0x2997, 0x2998), (0x29D8, 0x29D9), (0x29DA, 0x29DB),
    (0x29FC, 0x29FD), (0x2E22, 0x2E23), (0x2E24, 0x2E25), (0x2E26, 0x2E27),
    (0x2E28, 0x2E29), (0x2E42, 0x2E43), (0x3008, 0x3009), (0x300A, 0x300B),
    (0x300C, 0x300D), (0x300E, 0x300F), (0x3010, 0x3011), (0x3014, 0x3015),
    (0x3016, 0x3017), (0x3018, 0x3019), (0x301A, 0x301B), (0x301D, 0x301E),
    (0xFD3F, 0xFD40), (0xFE17, 0xFE18), (0xFE35, 0xFE36), (0xFE37, 0xFE38),
    (0xFE39, 0xFE3A), (0xFE3B, 0xFE3C), (0xFE3D, 0xFE3E), (0xFE3F, 0xFE40),
    (0xFE41, 0xFE42), (0xFE43, 0xFE44), (0xFE47, 0xFE48), (0xFE59, 0xFE5A),
    (0xFE5B, 0xFE5C), (0xFE5D, 0xFE5E), (0xFF08, 0xFF09), (0xFF3B, 0xFF3C),
    (0xFF5B, 0xFF5C), (0xFF5F, 0xFF60), (0xFF62, 0xFF63),
  ),

  'Sc': (
    (0x0024, 0x0025), (0x00A2, 0x00A6), (0x058F, 0x0590), (0x060B, 0x060C),
    (0x09F2, 0x09F4), (0x09FB, 0x09FC), (0x0AF1, 0x0AF2), (0x0BF9, 0x0BFA),
    (0x0E3F, 0x0E40), (0x17DB, 0x17DC), (0x20A0, 0x20BF), (0xA838, 0xA839),
    (0xFDFC, 0xFDFD), (0xFE69, 0xFE6A), (0xFF04, 0xFF05), (0xFFE0, 0xFFE2),
    (0xFFE5, 0xFFE7),
  ),

  'Sk': (
    (0x005E, 0x005F), (0x0060, 0x0061), (0x00A8, 0x00A9), (0x00AF, 0x00B0),
    (0x00B4, 0x00B5), (0x00B8, 0x00B9), (0x02C2, 0x02C6), (0x02D2, 0x02E0),
    (0x02E5, 0x02EC), (0x02ED, 0x02EE), (0x02EF, 0x0300), (0x0375, 0x0376),
    (0x0384, 0x0386), (0x1FBD, 0x1FBE), (0x1FBF, 0x1FC2), (0x1FCD, 0x1FD0),
    (0x1FDD, 0x1FE0), (0x1FED, 0x1FF0), (0x1FFD, 0x1FFF), (0x309B, 0x309D),
    (0xA700, 0xA717), (0xA720, 0xA722), (0xA789, 0xA78B), (0xAB5B, 0xAB5C),
    (0xFBB2, 0xFBC2), (0xFF3E, 0xFF3F), (0xFF40, 0xFF41), (0xFFE3, 0xFFE4),
    (0x1F3FB, 0x1F400),
  ),

  'Sm': (
    (0x002B, 0x002C), (0x003C, 0x003F), (0x007C, 0x007D), (0x007E, 0x007F),
    (0x00AC, 0x00AD), (0x00B1, 0x00B2), (0x00D7, 0x00D8), (0x00F7, 0x00F8),
    (0x03F6, 0x03F7), (0x0606, 0x0609), (0x2044, 0x2045), (0x2052, 0x2053),
    (0x207A, 0x207D), (0x208A, 0x208D), (0x2118, 0x2119), (0x2140, 0x2145),
    (0x214B, 0x214C), (0x2190, 0x2195), (0x219A, 0x219C), (0x21A0, 0x21A1),
    (0x21A3, 0x21A4), (0x21A6, 0x21A7), (0x21AE, 0x21AF), (0x21CE, 0x21D0),
    (0x21D2, 0x21D3), (0x21D4, 0x21D5), (0x21F4, 0x2300), (0x2320, 0x2322),
    (0x237C, 0x237D), (0x239B, 0x23B4), (0x23DC, 0x23E2), (0x25B7, 0x25B8),
    (0x25C1, 0x25C2), (0x25F8, 0x2600), (0x266F, 0x2670), (0x27C0, 0x27C5),
    (0x27C7, 0x27E6), (0x27F0, 0x2800), (0x2900, 0x2983), (0x2999, 0x29D8),
    (0x29DC, 0x29FC), (0x29FE, 0x2B00), (0x2B30, 0x2B45), (0x2B47, 0x2B4D),
    (0xFB29, 0xFB2A), (0xFE62, 0xFE63), (0xFE64, 0xFE67), (0xFF0B, 0xFF0C),
    (0xFF1C, 0xFF1F), (0xFF5C, 0xFF5D), (0xFF5E, 0xFF5F), (0xFFE2, 0xFFE3),
    (0xFFE9, 0xFFED), (0x1D6C1, 0x1D6C2), (0x1D6DB, 0x1D6DC), (0x1D6FB, 0x1D6FC),
    (0x1D715, 0x1D716), (0x1D735, 0x1D736), (0x1D74F, 0x1D750), (0x1D76F, 0x1D770),
    (0x1D789, 0x1D78A), (0x1D7A9, 0x1D7AA), (0x1D7C3, 0x1D7C4), (0x1EEF0, 0x1EEF2),
  ),

  'So': (
    (0x00A6, 0x00A7), (0x00A9, 0x00AA), (0x00AE, 0x00AF), (0x00B0, 0x00B1),
    (0x0482, 0x0483), (0x058D, 0x058F), (0x060E, 0x0610), (0x06DE, 0x06DF),
    (0x06E9, 0x06EA), (0x06FD, 0x06FF), (0x07F6, 0x07F7), (0x09FA, 0x09FB),
    (0x0B70, 0x0B71), (0x0BF3, 0x0BF9), (0x0BFA, 0x0BFB), (0x0C7F, 0x0C80),
    (0x0D4F, 0x0D50), (0x0D79, 0x0D7A), (0x0F01, 0x0F04), (0x0F13, 0x0F14),
    (0x0F15, 0x0F18), (0x0F1A, 0x0F20), (0x0F34, 0x0F35), (0x0F36, 0x0F37),
    (0x0F38, 0x0F39), (0x0FBE, 0x0FC6), (0x0FC7, 0x0FCD), (0x0FCE, 0x0FD0),
    (0x0FD5, 0x0FD9), (0x109E, 0x10A0), (0x1390, 0x139A), (0x1940, 0x1941),
    (0x19DE, 0x1A00), (0x1B61, 0x1B6B), (0x1B74, 0x1B7D), (0x2100, 0x2102),
    (0x2103, 0x2107), (0x2108, 0x210A), (0x2114, 0x2115), (0x2116, 0x2118),
    (0x211E, 0x2124), (0x2125, 0x2126), (0x2127, 0x2128), (0x2129, 0x212A),
    (0x212E, 0x212F), (0x213A, 0x213C), (0x214A, 0x214B), (0x214C, 0x214E),
    (0x214F, 0x2150), (0x218A, 0x218C), (0x2195, 0x219A), (0x219C, 0x21A0),
    (0x21A1, 0x21A3), (0x21A4, 0x21A6), (0x21A7, 0x21AE), (0x21AF, 0x21CE),
    (0x21D0, 0x21D2), (0x21D3, 0x21D4), (0x21D5, 0x21F4), (0x2300, 0x2308),
    (0x230C, 0x2320), (0x2322, 0x2329), (0x232B, 0x237C), (0x237D, 0x239B),
    (0x23B4, 0x23DC), (0x23E2, 0x23FF), (0x2400, 0x2427), (0x2440, 0x244B),
    (0x249C, 0x24EA), (0x2500, 0x25B7), (0x25B8, 0x25C1), (0x25C2, 0x25F8),
    (0x2600, 0x266F), (0x2670, 0x2768), (0x2794, 0x27C0), (0x2800, 0x2900),
    (0x2B00, 0x2B30), (0x2B45, 0x2B47), (0x2B4D, 0x2B74), (0x2B76, 0x2B96),
    (0x2B98, 0x2BBA), (0x2BBD, 0x2BC9), (0x2BCA, 0x2BD2), (0x2BEC, 0x2BF0),
    (0x2CE5, 0x2CEB), (0x2E80, 0x2E9A), (0x2E9B, 0x2EF4), (0x2F00, 0x2FD6),
    (0x2FF0, 0x2FFC), (0x3004, 0x3005), (0x3012, 0x3014), (0x3020, 0x3021),
    (0x3036, 0x3038), (0x303E, 0x3040), (0x3190, 0x3192), (0x3196, 0x31A0),
    (0x31C0, 0x31E4), (0x3200, 0x321F), (0x322A, 0x3248), (0x3250, 0x3251),
    (0x3260, 0x3280), (0x328A, 0x32B1), (0x32C0, 0x32FF), (0x3300, 0x3400),
    (0x4DC0, 0x4E00), (0xA490, 0xA4C7), (0xA828, 0xA82C), (0xA836, 0xA838),
    (0xA839, 0xA83A), (0xAA77, 0xAA7A), (0xFDFD, 0xFDFE), (0xFFE4, 0xFFE5),
    (0xFFE8, 0xFFE9), (0xFFED, 0xFFEF), (0xFFFC, 0xFFFE), (0x10137, 0x10140),
    (0x10179, 0x1018A), (0x1018C, 0x1018F), (0x10190, 0x1019C), (0x101A0, 0x101A1),
    (0x101D0, 0x101FD), (0x10877, 0x10879), (0x10AC8, 0x10AC9), (0x1173F, 0x11740),
    (0x16B3C, 0x16B40), (0x16B45, 0x16B46), (0x1BC9C, 0x1BC9D), (0x1D000, 0x1D0F6),
    (0x1D100, 0x1D127), (0x1D129, 0x1D165), (0x1D16A, 0x1D16D), (0x1D183, 0x1D185),
    (0x1D18C, 0x1D1AA), (0x1D1AE, 0x1D1E9), (0x1D200, 0x1D242), (0x1D245, 0x1D246),
    (0x1D300, 0x1D357), (0x1D800, 0x1DA00), (0x1DA37, 0x1DA3B), (0x1DA6D, 0x1DA75),
    (0x1DA76, 0x1DA84), (0x1DA85, 0x1DA87), (0x1F000, 0x1F02C), (0x1F030, 0x1F094),
    (0x1F0A0, 0x1F0AF), (0x1F0B1, 0x1F0C0), (0x1F0C1, 0x1F0D0), (0x1F0D1, 0x1F0F6),
    (0x1F110, 0x1F12F), (0x1F130, 0x1F16C), (0x1F170, 0x1F1AD), (0x1F1E6, 0x1F203),
    (0x1F210, 0x1F23C), (0x1F240, 0x1F249), (0x1F250, 0x1F252), (0x1F300, 0x1F3FB),
    (0x1F400, 0x1F6D3), (0x1F6E0, 0x1F6ED), (0x1F6F0, 0x1F6F7), (0x1F700, 0x1F774),
    (0x1F780, 0x1F7D5), (0x1F800, 0x1F80C), (0x1F810, 0x1F848), (0x1F850, 0x1F85A),
    (0x1F860, 0x1F888), (0x1F890, 0x1F8AE), (0x1F910, 0x1F91F), (0x1F920, 0x1F928),
    (0x1F930, 0x1F931), (0x1F933, 0x1F93F), (0x1F940, 0x1F94C), (0x1F950, 0x1F95F),
    (0x1F980, 0x1F992), (0x1F9C0, 0x1F9C1),
  ),

  'Zl': (
    (0x2028, 0x2029),
  ),

  'Zp': (
    (0x2029, 0x202A),
  ),

  'Zs': (
    (0x0020, 0x0021), (0x00A0, 0x00A1), (0x1680, 0x1681), (0x2000, 0x200B),
    (0x202F, 0x2030), (0x205F, 0x2060), (0x3000, 0x3001),
  ),

}


double_width_codes: List[Tuple[int, int]] = [ # Code points with East Asian Width 'W' or 'F'.
  (0x1100, 0x1160), (0x231A, 0x231C), (0x2329, 0x232B), (0x23E9, 0x23ED),
  (0x23F0, 0x23F1), (0x23F3, 0x23F4), (0x25FD, 0x25FF), (0x2614, 0x2616),
  (0x2648, 0x2654), (0x267F, 0x2680), (0x2693, 0x2694), (0x26A1, 0x26A2),
  (0x26AA, 0x26AC), (0x26BD, 0x26BF), (0x26C4, 0x26C6), (0x26CE, 0x26CF),
  (0x26D4, 0x26D5), (0x26EA, 0x26EB), (0x26F2, 0x26F4), (0x26F5, 0x26F6),
  (0x26FA, 0x26FB), (0x26FD, 0x26FE), (0x2705, 0x2706), (0x270A, 0x270C),
  (0x2728, 0x2729), (0x274C, 0x274D), (0x274E, 0x274F), (0x2753, 0x2756),
  (0x2757, 0x2758), (0x2795, 0x2798), (0x27B0, 0x27B1), (0x27BF, 0x27C0),
  (0x2B1B, 0x2B1D), (0x2B50, 0x2B51), (0x2B55, 0x2B56), (0x2E80, 0x2E9A),
  (0x2E9B, 0x2EF4), (0x2F00, 0x2FD6), (0x2FF0, 0x2FFC), (0x3000, 0x303F),
  (0x3041, 0x3097), (0x3099, 0x3100), (0x3105, 0x312E), (0x3131, 0x318F),
  (0x3190, 0x31BB), (0x31C0, 0x31E4), (0x31F0, 0x321F), (0x3220, 0x3248),
  (0x3250, 0x32FF), (0x3300, 0x4DC0), (0x4E00, 0xA48D), (0xA490, 0xA4C7),
  (0xA960, 0xA97D), (0xAC00, 0xD7A4), (0xF900, 0xFB00), (0xFE10, 0xFE1A),
  (0xFE30, 0xFE53), (0xFE54, 0xFE67), (0xFE68, 0xFE6C), (0xFF01, 0xFF61),
  (0xFFE0, 0xFFE7), (0x16FE0, 0x16FE1), (0x17000, 0x187ED), (0x18800, 0x18AF3),
  (0x1B000, 0x1B002), (0x1F004, 0x1F005), (0x1F0CF, 0x1F0D0), (0x1F18E, 0x1F18F),
  (0x1F191, 0x1F19B), (0x1F200, 0x1F203), (0x1F210, 0x1F23C), (0x1F240, 0x1F249),
  (0x1F250, 0x1F252), (0x1F300, 0x1F321), (0x1F32D, 0x1F336), (0x1F337, 0x1F37D),
  (0x1F37E, 0x1F394), (0x1F3A0, 0x1F3CB), (0x1F3CF, 0x1F3D4), (0x1F3E0, 0x1F3F1),
  (0x1F3F4, 0x1F3F5), (0x1F3F8, 0x1F43F), (0x1F440, 0x1F441), (0x1F442, 0x1F4FD),
  (0x1F4FF, 0x1F53E), (0x1F54B, 0x1F54F), (0x1F550, 0x1F568), (0x1F57A, 0x1F57B),
  (0x1F595, 0x1F597), (0x1F5A4, 0x1F5A5), (0x1F5FB, 0x1F650), (0x1F680, 0x1F6C6),
  (0x1F6CC, 0x1F6CD), (0x1F6D0, 0x1F6D3), (0x1F6EB, 0x1F6ED), (0x1F6F4, 0x1F6F7),
  (0x1F910, 0x1F91F), (0x1F920, 0x1F928), (0x1F930, 0x1F931), (0x1F933, 0x1F93F),
  (0x1F940, 0x1F94C), (0x1F950, 0x1F95F), (0x1F980, 0x1F992), (0x1F9C0, 0x1F9C1),
  (0x20000, 0x2FFFE), (0x30000, 0x3FFFE),
]
